/***********************************************************************
 Nefarious IRCu ChangeLog

2008-08-03  Matthew Beeching  <jobe@mdbnet.co.uk>

	* ircd/s_user.c: Fix for user mode +c and +C handling.

2008-08-03  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* configure: Regenerated.

	* Makefile.in: Help file install fixed this time.

	* ircd/os_bsd.c: times fix.

2008-08-03  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* Makefile.in: Small tweak.

2008-07-29  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/*: revert previous compile warning fixes on stable branch

	* ircd/ircd.c: remove debug code which got committed by mistake

	* ircd/s_bsd.c: remove debug code which got committed by mistake

2008-07-29  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* Happy Birthday to me ;P

	* ircd/s_user.c: Fixed an issue with msntv clients disconnecting on connect.

2008-07-26  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/s_serv.c: Fixed an issue with blank CVERSION's being sent out.

2008-07-21  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/channel.c: Dummy function that will grab and ignore params for
	excepts and half ops if either are enabled so that other params are passed.

2008-07-19  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* include/ircd_features.h: Added FEAT_LASTMOD_TWEAK. (undocumented)

	* ircd/ircd_features.c: Added FEAT_LASTMOD_TWEAK (default FALSE).

	* ircd/m_gline.c: If FEAT_LASTMOD_TWEAK is enabled then if a
	server sends a gline without a lastmod then its set to CurrentTime.

	* ircd/m_shun.c: If FEAT_LASTMOD_TWEAK is enabled then if a
	server sends a shun without a lastmod then its set to CurrentTime.

	* ircd/m_zline.c: If FEAT_LASTMOD_TWEAK is enabled then if a
	server sends a zline without a lastmod then its set to CurrentTime.

2008-07-19  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/gline.c: Show lastmod time in stats G and /gline.

	* ircd/jupe.c: Show lastmod time in /jupe.

	* ircd/s_err.c: Added extra %Tu for showing mod times.

	* ircd/shun.c: Show lastmod time in stats S and /shun.

	* ircd/zline.c: Show lastmod time in stats Z and /zline.

2008-07-14  Matthew Beeching  <jobe@mdbnet.co.uk>

	* ircd/listener.c: Fixed the P:Line flag H not actually hiding
	ports in the STATS P output.

2008-07-05  Matthew Beeching  <jobe@mdbnet.co.uk>

	* ircd/m_check.c: Added "IRC Administrator" to the status line
	and fixed the "Network Service" status line too.

2008-07-02  Matthew Beeching  <jobe@mdbnet.co.uk>

	* ircd/gline.c: PRIV_BADCHAN was not checked.

	* ircd/m_jupe.c: Replaced PRIV_GLINE and PRIV_LOCAL_GLINE
	with PRIV_JUPE and PRIV_LOCAL_JUPE

	* ircd/m_list.c: PRIV_LIST_CHAN was not checked

	* ircd/m_who.c: PRIV_WHOX had no effect

	* ircd/client.c: Various PRIV_* flag fixes

	* ircd/ircd_features.c: Added F:OPER_LIST_CHAN
	for PRIV_LIST_CHAN

	* include/ircd_features.h: Added F:OPER_LIST_CHAN
	for PRIV_LIST_CHAN

2008-06-25  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* help/opers/index: Added GLOBOPS.

	* help/opers/globops: Added GLOBOPS help file.

2008-06-24  Matthew Beeching  <jobe@mdbnet.co.uk>

	* ircd/send.c: Small fix for 'A' that should have been an 'a'
	in SMO handling.

2008-06-24  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* include/handlers.h: Added globops and smp function declerations.

	* include/msg.h: Added GLOBOPS and SMO.

	* include/send.h: SMO function declerations.

	* ircd/Makefile.in: Added m_smo.c and m_globops.c.

	* ircd/m_globops.c: Command that sends messages to all opers
	using SMO.

	* ircd/m_smo.c: Similar to SNO this sends messages to currently
	all opers or admins on the network. It can be extended to handle
	other user modes.

	* ircd/parse.c: Added GLOBOPS and SMO.

	* ircd/send.c: Functions to handle SMO.

2008-06-10  Alex Schumann  <rubin@afternet.org>

	* ircd/s_bsd.c: disabling IPcheck (its very broken)

	* ircd/s_misc.c: disabling IPcheck

	* ircd/s_auth.c: disabling IPcheck

	* ircd/m_webirc.c: disabling IPcheck

	* ircd/s_serv.c: disabling IPcheck

	* ircd/m_nick.c: disabling IPcheck

	* ircd/ircd.c: disabling IPcheck

	* ircd/s_user.c: disabling IPcheck

	* ircd/s_conf.c: disabling IPcheck

2008-06-10  Matthew Beeching  <jobe@mdbnet.co.uk>

	* ircd/ircd_relay.c: Private message relay checks for usermode +D

	* ircd/m_whois.c: Show if client accepts private messages

	* ircd/m_invite.c: Prevent invite to +D client

	* ircd/s_user.c: Added user mode +D

	* ircd/s_err.c: Added numeric responses for user mode +D

	* include/numeric.h: Added numeric responses for user mode +D

	* include/client.h: Added user mode +D

2008-06-10  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* Cleaned up the last of the references to GPL 2, switched them to
	GPL 3.

2008-06-10  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* help/Makefile.in: Added COMMANDS symlink.

	* help/opers/commands: Added COMMANDS help file.

	* help/users/index: Added COMMANDS.

	* include/handlers.h: Added m_commands.

	* include/msg.h: Added COMMANDS.

	* ircd/m_commands.c: Added COMMANDS command, this lists all commands
	available including s2s commands. Pretty much what the old HELP
	command used to do.

	* ircd/parse.c: Added COMMANDS.

2008-06-09  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/m_check.c: Remote CHECK support. Plus a tweak for server user
	counts.

2008-06-09  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* include/motd.h: Split motd_init into remote and local init
	functions.

	* include/ircd_features.h: Added uint F:lines.

	* include/s_user.h: Backported UnderNet's .12 new isupport code.

	* include/supported.h: Removed the old isupport code.

	* ircd/ircd.c: Init isupport on load. Removed motd_init. Handled else
	where now.

	* ircd/ircd_features.c: Backported UnderNet's .12 new isupport code.
	Also added support for alias and deprecated features

	* ircd/motd.c: Split motd_init into remote and local init functions.

	* ircd/s_user.c: Backported UnderNet's .12 new isupport code.

	* ircd/ssl.c: Initilize a few variables in ssl_init.

2008-06-06  Matthew Beeching  <jobe@mdbnet.co.uk>

	* ircd/channel.c: Fix for auto channel mode propagation

	* include/supported.h: Minor tweak to numeric 005 output

2008-05-25  Matthew Beeching  <jobe@mdbnet.co.uk>

	* ircd/m_opermotd.c: Fixed "Permission denied" error during
	remote oper

	* ircd/ircd_relay.c: Fix to prevent user mode +R evasion bug

	* ircd/s_user.c: Fix for ERR_ACCOUNTONLY reply sending source
	twice instead of source and destination 

2008-05-11  Matthew Beeching  <jobe@mdbnet.co.uk>

	* ircd/s_user.c: Fix for missing and duplicated "logged on"
	messages in watch list handling

2008-05-06  Matthew Beeching  <jobe@mdbnet.co.uk>

	* ircd/watch.c: Missed a line for previous fix for watch

	* ircd/m_watch.c: Missed a line for previous fix for watch

2008-05-05  Matthew Beeching  <jobe@mdbnet.co.uk>

	* ircd/watch.c: Fix for bug where a user could get any other user's
	real IP/host by adding them to their watch list.

2008-05-01  Matthew Beeching  <jobe@mdbnet.co.uk>

	* ircd/s_user.c: Fix for issue where I:Line overriding max per IP limit
	with a number greater then 9 causes a Bad Password error on connect

2008-04-28  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* Patch below by Osiris (1479281)

	* include/ircd_features.h: Added F:line CHMODE_e_CHMODEEXCEPTION.

	* ircd/channel.c: Added CHMODE_e_CHMODEEXCEPTION. Allows +e to be
	used as a general exemption to +k/+i/+l

	* ircd/ircd_features.c: Added CHMODE_e_CHMODEEXCEPTION. Default FALSE.

2008-04-21  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/m_watch.c: Patch from Jobe, WATCH tweak.

2008-04-20  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/m_webirc.c: Patch from Jobe, fixes for throttle checks.

2008-04-19  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* help/opers/index: Index file for oper help.

2008-04-19  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* help/users/index: Index file for user help.

2008-04-17  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/m_silence.c: Patch from ButtaKnife. Ignore silences for users
	that have quit.

2008-04-16  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* help/*: Quick snomask help file based on snomask.html.

2008-04-16  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* help/*: Added who commands.

2008-04-16  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* help/*: User and channel modes help files, cheers Jobe.

2008-04-16  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* help/*: Help files for gline, shun and zline.

2008-04-13  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/m_help.c: Replaceables for personalising help output.
	%n nick, %u username, %h hostname, %i ip address, %s server name,
	%N network name.

2008-04-13  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* help/*: More help files added.

2008-04-13  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* help/*: More help files added.

2008-04-12  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/m_challenge.c: Small tweak to header.

2008-04-12  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* include/handlers.h: Added ms_challenge and mo_challenge.

	* ircd/m_challenge.c: Added support for remote challenge's.

	* ircd/parse.c: Added ms_challenge and mo_challenge into challenge
	command.

2008-04-09  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/m_challenge.c: Fixed bug with log_write line not showing
	oper name.

2008-04-09  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/watch.c: Patch from Jobe to fix some WATCH issues with mIRC.

2008-04-08  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* include/client.h: Change SNO_ALL to account for the new snomask.

	* ircd/ircd_log.c: Added NICKCHG to valid snomasks.

	* ircd/s_user.c: Fixed up username and hostname display on snomask
	nick changes.

2008-04-08  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* doc/snomask.html: Updated.

	* include/client.h: Added SNO_NICKCHG.

	* ircd/s_user.c: Added SNO_NICKCHG, only send nick changes if a
	person has this sno mask set. Rather than sending them with
	client connects and quits.

2008-04-07  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* config.h.in: Ran autoheader.

	* configure: Regenerated.

	* configure.in: Added dev null check.

	* include/ssl.h: Added fd check function i nearly forgot about.

	* ircd/Makefile.in: Ran make depend.

	* ircd/ssl.c: Added fd check function i nearly forgot about.

2008-04-07  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/m_names.c: Fixed a buffer overflow with m_names with the
	new UHNAMES functionality.

2008-04-07  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/s_err.c: Numeric typo fix.

2008-04-06  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* help/Makefile.in: Added user relevent help files..

	* help/opers/: More help files.

2008-04-06  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* help/Makefile.in: Added ison join kick help motd into SYMLINKS.

	* help/opers/: Added ison join kick help motd opermotd.

2008-04-06  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* help/Makefile.in: Added new help files to SYMLINK line. Any help files
	that are written for both opers and users just need to be put in the
	opers dir, added to the SYMLINK line and make install will create a 
	symlink in the users dir to the command in the opers dir.

	* help/opers/: Added admin away challenge invite names nick version.

	* ircd/m_help.c: Fixed a small bug.

	* ircd/s_err.c: Fixed a small bug.

2008-04-06  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* help/users/index: Fixed index display.

	* help/opers/index: Fixed index display.

2008-04-05  Alex Schumann  <rubin@afternet.org>

	* help/Makefile.in: fix distclean bug

2008-04-05  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* configure: Regenerated.

	* configure.in: Process the Makefile in the help directory.

	* Makefile.in: Process the help directory.

	* doc/example.conf: Added F:HELP_PACE:5.

	* help/*: Help files.

	* include/ircd_features.h: Added FEAT_HELP_PACE.

	* include/msg.h: Added UHELP.

	* include/numeric.h: Added numerics for new help system.

	* ircd/ircd_features.c: Added HELP_PACE, default 5. By default help
	can be requested every 5 seconds.

	* ircd/m_help.c: Re did the help system using the code from hybrid.

	* ircd/parse.c: Added UHELP so opers can request user help files.

	* ircd/s_err.c: Added numerics.

2008-04-05  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* doc/CIDR.txt: This should be of some use to people. Explains
	CIDR masks. (Grabbed from hybrid docs dir).

2008-04-05  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* doc/challenge.txt: Document detailing on the new challenge system.

	* doc/example.conf: Added a section to the O:line section detailing
	how to use RSA keys with O:lines.

	* include/client.h: Added O:line flag R (RSA).

	* include/handlers.h: Added handler for m_challenge.

	* include/ircd_struct.h: Added some entries into the client struct.

	* include/msg.h: Added CHALLENGE.

	* include/numeric.h: Added numerics for challenge system.

	* include/ssl.h: Declare new functions for handling RSA keys.

	* ircd/Makefile.in: Run mkkeypair after compiling.

	* ircd/m_challenge.c: Added a port of hybrids challenge system. The
	system uses RSA keys to authenticate opers.

	* ircd/m_oper.c: If an O:line has an R flag then deny normal /OPER'ing

	* ircd/s_err.c: Added numerics for challenge system.

	* ircd/parse.c: Added CHALLENGE command.

	* ircd/ssl.c: Added functions to handle RSA keys.

	* tools/mkkeypair: Generates a RSA key for the server.

	* tools/rsa_respond*: Program that turns the challenge output into
	a response.

2008-04-03  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/m_check.c: Only show the version in CHECK if its set.

2008-04-03  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/s_serv.c: Only send MARK CVERSION's if there is a version
	available.

2008-04-02  Alex Schumann  <rubin@afternet.org>

	* ircd/s_conf.c: fix bug in ircd.conf include line (using memory we just free'd)

2008-04-02  Alex Schumann  <rubin@afternet.org>

	* ircd/m_account.c: LOC send host patch by Jobe

	* ircd/s_user.c: LOC send host patch by Jobe

	* ircd/ircd_features.c: LOC send host patch Jobe

	* include/ircd_features.h: LOC send host patch Jobe

2008-04-01  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/m_svsquit.c: Send SVSQUIT's to remote servers if we need	
	to.

2008-04-01  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* include/msg.h: Im a dumbass, changed the prefix for SVSQUIT
	from SQ to SX as SQ is already in use with SQUIT.

2008-03-28  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/m_svsquit.c: Removed the prefixing.

2008-03-28  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/handlers.h: Added ms_svsquit decleration.

	* ircd/msg.h: Added SVSQUIT as SQ token.

	* ircd/m_svsquit.c: When sent from another server this will make
	a client quit on the server as if the client did /quit <msg>.

	* ircd/parse.c: Added SVSQUIT.

2008-03-27  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/m_mark.c: Must of been on something when i did this. Send
	the numeric not the actual server name in m_mark.c. Spotted by
	Jobe.

2008-03-27  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/m_mark.c: Turned the protocol violation into just simple
	logging. This way in the future we if theres new marks that dont
	have F:lines they wont spam the network with protocol_violations
	during network upgrades.

2008-03-26  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* Fix by Jobe.

	* include/client.h: Added FLAG_PROPAGATED.

	* ircd/s_user.c: Fixed an issue with default user modes being sent
	before the N token.

2008-03-23  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* Reverted last commit for now.

2008-03-23  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* include/gline.c: Declerations for regexp glines.

	* include/shun.c: Declerations for regexp shuns.

	* ircd/gline.c: Merged in Outsider's Regexp gline code
	http://sourceforge.net/projects/scarynet

	* ircd/gline.c: Used Outsider's gline regexp code to add regexp
	functionality in shuns.

2008-03-22  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* include/client.h: Added UHNAMES.

	* include/s_user.h: Added extra param to set_nick_name.

	* include/supported.h: Added UHNAMES.

	* ircd/m_names.c: Added UHNAMES support, if a client supports this
	then it will send a PROTOCTL UHNAMES on connect. From there on
	any NAMES output will contain the full username!ident@hostname.
	This saves on clients having to use WHO to get user hosts. Currently
	mIRC and Klient support this.

	* ircd/m_nick.c: Added extra param to set_nick_name.

	* ircd/m_protoctl.c: Added UHNAMES.

	* ircd/m_svsnick.c: Added extra param to set_nick_name.

	* ircd/s_user.c: Allow nick changes via SVSNICK to skip limit
	and U:line checkss.

2008-03-22  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/m_svsjoin.c: Added support for SVSJOIN 0 to part all
	channels.

	* ircd/s_user.c: Fixed an issue with default umode's applying to
	remote users.

2008-03-22  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* This change log reflects the changes i made to the restart/die
	with schedules code. The full change log is in ChangeLog.

	* ircd/listener.h: Tweaked add_listener to handle is_exempt.

	* ircd/listener.c: Tweaked add_listener to handle is_exempt. Also
	fixed up the flag displaying code in /stats p.

	* ircd/Makefile.in: Ran make depend.

	* ircd/m_die.c: Intergrated the scheduled die code with the die
	password code.

	* ircd/m_rehash.c: As we already had ms_rehash i just inserted the
	check for NETWORK_REHASH.

	* ircd/m_restart.c: Intergrated the scheduled restart code with the
	restart password code.

	* ircd/s_conf.c: Fixed up the P:line flag processing code.

2008-03-15  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/m_mark.c: Bug fix from Jobe.

	* ircd/m_notice.c: Bug fix from Vadtec.

2008-03-11  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* include/ircd_string.h: more declerations.

	* ircd/ircd_string.c: Added one more function from denora which
	cleans up buffers.

	* ircd/m_notice.c: Make sure of the new function.

2008-03-11  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* include/ircd_string.h: normalizebuffer decleration.

	* ircd/ircd_string.c: Added a function from denora which removes
	control codes etc from buffers.

	* ircd/m_notice.c: Make sure of the new function to strip out
	the \001's from the version replies.

2008-03-11  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/m_svsident.c: Fixed up sending of the change to other
	servers.

	* ircd/m_svsinfo.c: Fixed up sending of the change to other
	servers.

2008-03-11  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/s_user.c: Move the auto usermode code to before the nick
	is sent out. That way the modes will go with the NICK. If host
	hiding style 2 is used then services will hide the host straight
	away.

2008-03-11  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/s_user.c: What was i thinking? Bug fix from Jobe.

2008-03-04  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* README: Small tweak mostly to make sure snapshots are working
	again.

2008-03-03  Alex Schumann  <rubin@afternet.org>

	* ircd/m_oper.c: fixing compilation bug from previous rev

2008-03-04  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/example.conf: Removed ORIGINAL_BLINES as Jobe found the
	fix for the duplicates.

	* include/ircd_features.h: See above.

	* ircd/ircd_features.h: See above.

	* ircd/m_oper.c: Fixed a bug found by Jobe. Remote oper hosts
	were not showing up properly.

	* ircd/parse.c: Me and pointers... oh dear. Fixed a bug which
	completly broke linking with my last commit.

	* ircd/send.c: Removed ORIGINAL_BLINES as Jobe found the fix for
	the duplicates.

2008-03-03  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/parse.c: Take a copy of the buffer before its trashed and
	then if theres a missing prefix output whats in the backup. This
	is a better way of doing this rather than logging everything.

2008-03-03  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/Makefile.in: Run svncheck before compiling.

	* ircd/svncheck.sh: Check svn for the latest updates. If there
	are any updates available then echo a message.
	
2008-03-03  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* include/handlers.h: Added ms_svsident/svsmode.

	* include/msg.h: Added SVSIDENT and SVSMODE.

	* include/s_user.h: Added define for magic usermode changes.

	* ircd/Makefile.in: Added m_svsident.c and m_svsmode.c. Also
	disabled auto svn updates (not my call).

	* ircd/m_svsident.c: Ability for servers to change user idents.

	* ircd/m_svsmode.c: Ability for servers to change user modes.

	* ircd/m_svsnoop.c: Removed use of  hunt server command as its
	shit. Replaced with a different way of doing that hunt server
	command does. Also fixed a couple of other bugs i found.

	* ircd/parse.c: Added SVSIDENT and SVSMODE.

	* ircd/s_user.c: Change usermodes if its a SVSMODE with magic.

2008-03-03  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* configure: Regenerated.

	* configure.in: Check for subversion on configure, if its not
	installed give a warning. Also updated Nefarious's version.

	* ircd/Makefile.in: If subversion is install then before we
	compile do a svn update.

2008-03-03  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/s_misc.c: Send the real host not a crypted host in oper	
	quit notices.

	* ircd/zline.c: Broadcast zline active notices to all opers who
	recieve them.

2008-03-02  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/gline.c: Broadcast gline active notices to all opers
	who recieve them.

	* ircd/m_oper: Broadcast oper sucessful, failed, etc notices to
	all opers who recieve them.

	* ircd/s_misc.c: Broadcast client exit notices to all opers
	who recieve them.

	* ircd/s_user.c: Broadcast client exit notices and shun active
	notices to all opers who recieve them.

	* ircd/shun.c: Broadcast shun active notices to all opers
	who recieve them.

2008-03-02  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/send.c: Woops missed this.

2008-03-02  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* include/handlers.h: Added ms_sno.

	* include/send.h: Added decleration for new sending to all opers
	commands.

	* include/msg.h: Added SNO.

	* ircd/m_sno.c: From ircoderz2, allows servers to send global
	oper notices.

	* include/Makefile.in: Added m_sno.c.

	* ircd/parse.c: Added SNO.

	* ircd/send.c: Added functions to send notices to all opers.

2008-03-02  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* doc/example.conf: Added F:line ORIGINAL_BLINES (default false).

	* doc/ircd_features.c: See above.

	* ircd/ircd_features.c: See above.

	* ircd/send.c: If ORIGINAL_BLINES is set to TRUE, then b:lines will
	function as the were originally intended. Prefixed commands
	will be sent to services even if they are off channel.

2008-03-01  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* doc/example.conf: Changed the default message so it fits in
	with the connection notices.

	* ircd/ircd_features.c: Changed the default message so it fits 
	in with the connection notices.

2008-03-01  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/s_user.c: Moved the CTCP version back to as early as possible.
	It now sends just before the Welcome to the... numerics.

2008-03-01  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* doc/example.conf: Added new F:line CTCP_VERSIONING_NOTICE.

	* include/ircd_features.c: Added FEAT_CTCP_VERSIONING_NOTICE.

	* ircd/ircd_features.c: Added F:line CTCP_VERSIONING_NOTICE.

	* ircd/s_user.c: If CTCP_VERSIONING_NOTICE is set then send out	a
	the message just before they are checked. If its set to "" then
	no notice will be sent.

2008-03-01  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/m_mark.c: Fixed a wee bug.

	* ircd/s_serv.c: Send versions on link.

2008-03-01  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* include/mark.h: Added MARK_CVERSION for sending out client
	versions.

	* ircd/m_check.c: If cli_version is filled then show it in /CHECK.

	* ircd/m_mark.c: Handle incoming MARK_CVERSION's.

	* ircd/m_notice.c: Send out MARK_CVERSION's using MARK to other
	servers.

2008-03-01  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* Patch Below By Jobe.

	* include/client.h: NAMESX flag.

	* include/handlers.h: Handlers for PROTOCTL.

	* include/supported.h: Added support for NAMESX.

	* ircd/Makefile.in: Added m_protoctl.c

	* ircd/m_names.c: If a client is NAMESX capable then send all modes
	in NAMES output.

	* ircd/m_protoctl.c: If a client supports this then on connect if it
	sees NAMEX in the server headers then it will send back PROTOCTL
	NAMEX to say it supports it. mIRC and Xchat support this.

	* ircd/parse.c: Added PROTOCTL.

2008-02-29  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* doc/example.conf: Removed most of the references to AfterNET and added
	some basic sorting of the F:lines. If you think a F:line should be in
	another section let me know.

2008-02-29  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* Patch below by Vadtec

	* doc/example.conf: Documented K:line version support, also documented
	the new F:lines.

	* include/client.h: Store version replies

	* include/ircd_defs.h: Added VERSIONLEN.

	* include/ircd_features.h: Added new F:lines.

	* include/s_conf.h: Support for versions in K:lines.

	* ircd/ircd_features.c: Added new F:lines.

	* ircd/m_notice.c: If we get a CTCP reply then check it.

	* ircd/s_conf.c: Add $V support to K:lines.

	* ircd/s_user.c:  Check clients ctcp's on connect if enabled.

2008-02-29  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/md5.c: Fixed an issue with openssl 0.9.8.

2008-02-29  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/md5.c: Fixed a small compile issue without ssl enabled.

2008-02-28  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* Patch below by Jobe

	* doc/example.conf: Documented W:lines

	* include/client.h: Added FLAG_WEBIRC for marking cgi:irc clients.

	* include/handlers.h: Added handlers for webirc.

	* include/ircd_features.h: Added 4 F:lines (see example.conf changes).

	* include/msg.h: Added webirc command.

	* include/s_conf.h: Added W:lines.

	* ircd/Makefile.in: Added m_webirc.c.

	* ircd/ircd_features.c: Added 4 F:lines (see example.conf changes).

	* ircd/m_webirc.c: Added webirc commands.

	* ircd/parse.c: Added webirc command.

	* ircd/s_conf.c: Added W:lines.

	* ircd/s_stats.c: Added stats for W:lines.

	* ircd/s_user.c:  If FEAT_WEBIRC_USERIDENT is enabled then we need to
	set the clients ident.

2008-02-27  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* include/client.h: Moved DoMD5 to here.

	* include/md5.h: Different fix to the MD5_CTX issues.

	* ircd/md5.c: Different fix to the MD5_CTX issues.

	* ircd/s_user.c: Added a line i missed from Jobes last patch.

2008-02-27  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/s_user.c: Patch by Jobe. Fixes for cloaked hsots.

2008-02-26  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/s_user.c: Patch by Jobe for 1.1 and 1.2 linking compatability
	with style 2 hidden hosts.

2008-02-25  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* include/handlers.h: Added handlers for watch.

	* include/hash.h: Hash related code for holding watch's.

	* include/ircd_features.h: Added F:MAXWATCHS

	* include/list.h: Struct for watch's.

	* include/msg.h: WATCH command entries.

	* include/numeric.h: Added numerics for watch's.

	* include/struct.h: Watch counts.

	* include/supported.h: Added WATCH.

	* include/watch.h: Watch decelerations.

	* ircd/hash.c: Hold watch's in hash tables.

	* ircd/ircd_features.c: Added F:MAXWATCHS.

	* ircd/Makefile.am: Added m_watch.c and watch.c.

	* ircd/m_watch.c: Functions for /WATCH.

	* ircd/parse.c: Added WATCH command.

	* ircd/s_debug.c: Watch usage debug information.

	* ircd/s_err.c Added numerics for watch's.

	* ircd/s_misc.c: When we clean up after a user quits notify
	watch lists.

	* ircd/s_user.c: Monitor user connects and quits.

	* ircd/watch.c: More watch funcions.

2008-02-25  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/join.c: Propagate autochan modes.

	* ircd/m_svsjoin.c: Propagate autochan modes.

2008-02-25  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* doc/example.conf: See below.

	* include/ircd_features.h: Added a F:line which controls the nick
	change delay instead of being hard coded

	* include/supported.h: Added Ccz usermodes.

	* ircd/ircd_features.c: See ircd_features.h.

	* ircd/list.c: Added Jobes nick delay patch.

	* ircd/s_user.c: Added Jobes remote SSL status support and nick
	delay patch

2008-02-25  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/client.h: Added 2 new channel modes for sending cloaked
	hosts n ips with style 2 (+Cc).

	* ircd/s_user.c: Send out cloaked hosts n ips so other servers
	dont have to do extra work.

2008-02-25  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/s_bsd.c: Fixed Z:line crash. Fix by Jobe.

2008-02-25  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/hash.c: Added back in last active. Also added in a fix from
	Jobe where channels were not all being listed.

	* ircd/m_list.c: Re added last active code.

2008-02-24  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* doc/example.conf: Small fix.

2008-02-24  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* include/patchlevel.h: Bumped patch level.

2008-02-24  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* doc/example.conf: Added new conf lines.

	* include/cloak.h: Declerations for cloak.c.

	* include/ircd_defs.h: Removed style bits (KEY1/2/3). Controled
	via conf now.

	* include/ircd_struct.h: Increased the length of virtual ip.

	* include/ircd_features.h: Added new conf lines.

	* include/md5.h: Header file for md5 functions.

	* include/md5sum.h: Renamed from md5.h, this is for the md5 sum program
	which generates the sums for the c files.

	* ircd/cloak.c: Implement unreal ircd host hiding for style 2. More
	secure than the last type.

	* ircd/hash.c: Removed last active bits from LIST. ALIST can be used
	for last active.

	* ircd/hosthiding.c: Removed.

	* ircd/ircd_features.c: Added HOST_HIDING_PREFIX, HOST_HIDING_KEY1,
	HOST_HIDING_KEY2, HOST_HIDING_KEY3. All for style 2.

	* ircd/m_list.c: See hash.c.

	* ircd/Makefile.in: Added cloak.c and md5.c, removed hosthiding.c.

	* ircd/md5.c: MD5 functions for host hiding.

	* ircd/s_user.c: Implement new host hiding features.
	
2008-02-24  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* README: Added a special thanks section.

	* ircd/m_user.c: Fixed a nasty crash bug with USER. Thanks goes out
	to Vadtec for this fix.

2008-02-24  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

        * ircd/hash.c: fix for /list default not showing inactive channels
	bug. (thanks Jobe) (adding after the fact as changelog was left out
	-Rubin)

2008-01-20  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/m_svsjoin.c: Fixed up the way SVSJOIN is handled across servers.
	There should be no more duplicate NAMES's and TOPIC's.

2007-07-10  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* include/numeric.h: Added numeric for invalid Z:line mask.

	* ircd/zline.c: Use the new numeric.

	* ircd/s_err.c: Added new numeric.

2007-07-11  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* include/zline.h: Bug fix.

	* ircd/zline.c: Bug fix.

	* ircd/m_zline.c: Add debugging include.

2007-07-11  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* include/zline.h: Zap line support.

	* ircd/m_zline.c: Zap line support.

	* ircd/zline.c: Zap line support.

2007-07-10  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/ssl.c: Fixed some wierdness, missing line breaks.

2007-07-03  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/m_alist.c: Quick tweak.

2007-07-03  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* doc/example.conf: Added ALIST_SEND_FREQ, this defines how often
	ALIST updates are sent out. This is default to 300 seconds (every
	5 minutes). Also added ALIST_SEND_DIFF, only channels that are active
	within the last specified seconds will be sent out. This is default
	to 600 seconds (10 minutes). Both F:Lines are in seconds.

	* include/handlers.h: Added in ms_alist.

	* include/ircd_features.h: Added 2 new F:lines (see above).

	* ircd/channel.c: Only update last_message if the message comes
	from a regular client (not a service).

	* ircd/ircd.c: Added in ALIST timer.

	* ircd/ircd_features.h: Added 2 new F:lines

	* ircd/ircd_relay.c: Only update last_message if the message comes
	from a regular client (not a service).

	* ircd/m_alist.c: Added in ms_list to handle incomming ALIST updates.

	* ircd/parse.c: Added in ms_alist.

2007-07-02  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* doc/example.conf: Added default ALIST max output (F:DEF_ALIST_LIMIT).
	Default is 30.

	* include/ircd_features.c: Added default ALIST max output.

	* include/msg.h: Added ALIST.

	* ircd/ircd_features.c: Added default ALIST max output.

	* ircd/m_alist.c: ALIST command to show last active channels
	within the specified time. Format is ALIST <time> [limit]. Time
	is accepted as a timestamp or 2d1m2s format.

	* ircd/Makefile.in: Added m_alist.c.

	* ircd/parse.c: Added ALIST.

2007-06-30  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* include/patchlevel.h: Bumped patchlevel.

2007-06-30  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* Updated source code and LICENSE to GPL v3. Wasnt as hard as i
	thought it would be.

2007-06-30  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* Updated my email address throughout src.

	* doc/example.conf: Added SET_ACTIVE_ON_CREATE, default TRUE.

	* include/ircd_features.h: Added SET_ACTIVE_ON_CREATE.

	* include/channel.h: Added last_message variable to channel struct.

	* ircd/channel.c: Set the last_message time to the creation time
	when a channel is created. This is controlled by the F:Line
	SET_ACTIVE_ON_CREATE, if set to FALSE no channel will display in
	LIST output until a message has been sent to it.

	* ircd/hash.c: handle min_active and max_active.

	* ircd/ircd_features.c: Added SET_ACTIVE_ON_CREATE, default TRUE.

	* ircd/ircd_relay.c: If a person messages or notices a channel, update
	the chptr->last_message to the current time.

	* ircd/m_list.c: Allow LIST to show channels that have been active
	within a specified time.

	* ircd/ssl.c: Removed a // style command and a couple of unused
	variables.

2007-03-29  Alex Schumann  <rubin@afternet.org>

        * ircd/s_err.c: fix case of 'z' in ssl only error message.

	* include/ircd_features.h: new F line for strict username checking

	* ircd/ircd_features.c: new F line for strict username checking

	* ircd/s_user.c: added ability to turn off the checking that doesn't like
	 various mixed case & numbers in usernames. F:STRICTUSERNAME:FALSE (default is TRUE)

2007-03-03  Alex Schumann  <rubin@afternet.org>

	* ircd/ssl.c: more debugging info for ssl

	* ircd/send.c: fix for ssl 'write error: success' bug

2007-02-07  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* doc/example.conf: Added new F:line HIS_HIDEWHO, default TRUE.
	When enabled various actions preformed by servers like modes,
	invites, topic etc will display &his which is set via
	HIS_SERVERNAME. This is the current behaviour i just forgot to
	add an F:line to disable it.

	* doc/readme.features: Document F:line.

	* include/ircd_features.h: Added new F:line.

	* ircd/supported.h: Now that we can do server side searches with
	list we can have ELIST in the ISUPPORT line.

	* ircd/ircd_features.c: Added new F:line.

	* ircd/channel.c: If HIS_HIDWHO is on then use &me instead of &his.

	* ircd/m_burst.c: Likewise.

	* ircd/m_invite.c: Likewise.

	* ircd/m_kick.c: Likewise.

	* ircd/m_kill.c: Likewise.

	* ircd/m_topic.c: Likewise.

	* ircd/m_whois.c: Likewise.

	* ircd/s_misc.c: Likewise.

	* ircd/s_user.c: Likewise.

2007-02-04  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* doc/example.conf: Added new AUTOJOIN lines.

	* include/ircd_defs.h: Removed AUTOJOIN channel define.

	* include/ircd_features.h: Tweaked current AUTOJOIN lines and added
	oper and admin AUTOJOIN lines.

	* ircd/m_oper.c: Added admin and oper AUTOJOIN sections.

	* ircd/s_user.c: Tweaked AUTOJOIN section.

	* ircd/ssl.c: Quashed some warnings.

2007-01-27  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/channel.c: Couple of fixes.

2007-01-14  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/shun.c: Just a further tweak for the fix on the 7th.

2007-01-14  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/m_svspart.c: Possible fix for an issue we found on AfterNET.

2007-01-07  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* Includes an undernet backport, See ChangeLog.

	* ircd/parse.c: If we have a user and host then we can do a shun
	check.

	* ircd/shun.c: Seems theres cases where realusername (and possibly
	realhost are not being set before the shun_lookup check.

2006-12-17  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/channel.c: Important update. I wont go into too much detail
	but its to do with channel bans. See me if you want more info. I
	advise you update.

2006-09-12  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/m_topic.c: Bug fix with host in topic, missed a { } set.

2006-09-12  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/gline.c: Critical bug fix to BADCHANS (tested).

2006-09-06  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/s_auth.c: Add specific notices as to if someone matches
	or doesnt match on the dnsbl checks. Works properly now (tested).

	* ircd/s_serv.c: Clean up how silences are bursted.

2006-09-06  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/m_clearmode.c: Fix the old clearmode crash on bsd systems.

	* ircd/md5sum.c: Older bsd systems dont seem to have getopt however
	it seems unistd will sort this out.

2006-08-29  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/m_oper.c: Fix from branches for oper logging crash.

2006-08-22  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* include/ircd_struct.h: Bumped up the size of dnsblhost.

	* ircd/client.c: Send privs to servers on all opers.

	* ircd/s_serv.c: Burst privs on link.

	* ircd/s_user.c: Tweaked a couple of snprintf's, these could be
	causing the burst bug.

2006-07-27  Alex Schumann  <rubin@afternet.org>

	* ircd/s_user.c: Thwart unlikely buffer overrun if a user matched a
	_LOT_ of rbls with long names.

	* ircd/m_topic.c: Fix buffer overrun in /topic with host in topic set
	and a 30 char nick. This leads to a crash, and memory corruption. It
	is advised everyone either upgrade to this build or set F:NICKLEN:29
	or lower immediately.

2006-07-23  Alex Schumann  <rubin@afternet.org>

	* ircd/Makefile.in: stop overwriting existing motd and similar config
	files on make install (!!) *scowel*

2006-07-10  Alex Schumann  <rubin@afternet.org>

	* include/patchlevel.h: we decided 1.0.1 is better than 1.1

2006-07-11  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/gline.c: Tweaked username to realusername.

	* ircd/shun.c: Tweaked username to realusername.

2006-07-10  Alex Schumann  <rubin@afternet.org>

	* include/patchlevel.h: bumping this trunk to 1.1

2006-07-11  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/gline.c: Dont check GlineIsBadChan() here, its done else
	where.

2006-07-11  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/version.c.SH: Use md5sum that comes with nefarious. (again
	opps).

2006-07-11  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* configure: Ran autoconf.

	* configure.in: Added check for getopt.h

	* include/md5.h: A lot of systems dont seem to come with md5sum.
	This messes up the output in INFO, so heres a small md5sum
	program.

	* ircd/Makefile.in: Compile md5sum.c into md5sum at the start
	of complimation.

	* ircd/md5sum.c: See md5.h entry.

	* ircd/version.c.SH: Use md5sum that comes with nefarious.

2006-07-11  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* config.h.in: Ran autoheader.

	* configure: Ran autoconf.

	* configure.in: Removed nick glines. They never worked properly
	and it made the code damn hard to read.

	* doc/example.conf: Added feature HIS_SHUN_REASON. On by default,
	the shun reason will NOT be displayed to the target(s) when they
	are shunned.

	* doc/readme.features: Added HIS_SHUN_REASON.

	* include/gline.h: See configure.in entry.

	* include/ircd_features.h: See example.conf entry.

	* include/shun.h: Removed nick bits.

	* ircd/gline.c: See configure.in entry. Also grabbed a fresh copy
	of gline.c and readded our extra bits just to be safe.

	* ircd/ircd_features.c: See example.conf entry.

	* ircd/m_nick.c: See configure.in entry.

	* ircd/m_svsnick.c: See configure.in entry.

	* ircd/Makefile.in: Ran make depend.

	* ircd/s_debug.c: See configure.in entry.

	* ircd/s_err.c: See configure.in entry.

	* ircd/s_user.c: Make use of HIS_SHUN_REASON here.

	* ircd/shun.c: Redone using the fresh gline.c, shuns dont include
	nicknames now as that code is quite dodgy.

	* ircd/whocmds.c: See configure.in entry.

2006-07-10  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/m_mark.c: Woops one too many %s's.

	* ircd/s_user.c: No need to send it out anymore as we fully burst
	silences.

2006-07-10  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/m_silence.c: Send out the usual silence notice if a server
	or service adds a silence for you.

2006-07-10  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/m_oper.c: Apply an old fix with remote opering that was
	never applied to the trunk.

	* ircd/send.c: Silences apply to channel messages and notices.
	This needs a wee bit more testing *hint hint*.

2006-06-05  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/s_serv.c: Burst silences on link.

2006-06-05  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/m_silence.c: Send all ignores to all servers. This needs
	testing on our own testnet, committing so that the others can
	try it. Dont use this revision for a day or 2 atleast please.

	* ircd/send.c: Fixed a warning.

2006-06-03  Alex Schumann  <rubin@afternet.org>

	* ircd/m_exempt.c: experimental patch for exempt crash bug

	* ircd/m_silence.c: doesn't core anymore, but needs improvement to
	burst properly. Currently locally REMOVING a silence bursts, but not
	setting one locally....

2006-05-25  Alex Schumann  <rubin@afternet.org>

	* ircd/send.c: Made blines work to override umode +d
	for privmsgs starting with that prefix, and removed the previous
	(broken) offchannel cmdchar support.

2006-05-24  Alex Schumann  <rubin@afternet.org>

	* ircd/m_topic.c: fixed using wrong ident field for topic set

2006-05-22  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* include/patchlevel.h: Bumped patchlevel.

2006-05-22  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* include/handlers.h: Added decleration for ms_svsinfo.

	* include/msg.h: Added SVSINFO (SI).

	* ircd/Makefile.in: Added m_svsinfo.c

	* ircd/m_svsinfo.c: Services only command to change a users real
	name / info line.

	* ircd/parse.c: Added SVSINFO.

2006-05-22  Reed Loden  <reed@reedloden.com>

	* ircd/m_burst.c: Clean-up the "fix" somewhat and use a
	different method of checking.

2006-05-22  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/m_burst.c: Possibly fixed a bug were testing on our testnet,
	will know for sure when we update the testnet. + fix fix :) -rubin

2006-05-22  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/m_silence.c: Allow servers to set servers, we can now do
	centralized silence lists in X3.

	* ircd/s_conf.c: Tweaked one of rubin's comments.

2006-05-21  Alex Schumann  <rubin@afternet.org>

	* ircd/s_conf.c: Improved dnsbl support for more than 8 bit return
	values, such as zz.countries.nerd.dk. Added error when using 040 x
	line syntax with 050 to log (no rank).

2006-04-11  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* configure: Something updated this at some point, autoconf most
	likely.

	* ircd/channel.c: If your +e exempted then you can get past +ilkr
	now. If your able to get an exempt then you should be able to get
	past these modes.

2006-02-22  Alex Schumann <rubin@afternet.org>

	* configure: new version from output of above

	* configure.in: Added check for __res_mkquery in addition to res_mkquery
	as some 64bit linux distros seem to only have the hidden one.

	* config.h.in: setup define for res_mkquery __ prefix

	* ircd/res.c: Added define for res_init and res_mkquery functions

2006-02-12  Alex Schumann  <rubin@afternet.org>

	* ircd/s_stats.c: Applied a patch from muer to fix spacing problem in
	stats v.

2006-01-20  Reed Loden  <reed@reedloden.com>

	* ircd/m_account.c: Add missing breaks, more sanity checks,
	whitespacing changes, and cleaned-up protocol_violation()
	reply.

	* ircd/ssl.c: Whitespacing changes and use of |unsigned int|
	instead of |int|.

2006-01-08  Alex Schumann  <rubin@afternet.org>

	* ircd/ssl.c: attempted to make the ssl write code default to retrying
	instead of killing clients in unknown/unhandled circumstances. trying to
	fix 'the ssl bug'.

2005-10-28  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* include/s_conf.h: GCC 4.x compile fixes.

	* ircd/s_conf.h: GCC 4.x compile fixes.

2005-10-03  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* include/version.h: Declare othertext;

	* ircd/m_info.c: Display md5sums only to remote info queries.

	* ircd/version.c.SH: md5sums go into othertext now.

	* Commit 1336 Change:

	* ircd/m_join.c: Fixed a bug with FEAT_CREATE_CHAN_OPER_ONLY.

2005-10-03  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/Makefile.in: Send the source path when generating version
	information.

	* ircd/version.c.SH: .12 Style md5sum output in INFO.

2005-10-03  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/m_whois.c: Fixed a bug with WHOIS. Should of realised this
	before instead of just reverting.

2005-10-03  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/Makefile.in: Ran make depend.

	* Undernet Updates, see Changelog.

2005-09-08  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/m_topic.c: Some changes to topic so that Nefarious wont
	core when it gets a 0.4.0 style topic from a server. There will
	probably be some oddness (nothing major) if you have 0.4.0 servers
	and 0.5.0 servers but that will clear itself as the network
	updates itself.

2005-08-30  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/s_user.c: Trialing without an assert.

2005-08-29  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/m_topic.c: Fixes with handling topic bursts containing the
	setter.

2005-08-27  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* include/s_user.h: Added extra param for determining if a sethost
	is comming from a server or not. (set_hostmask)

	* ircd/m_sethost.c: Updated set_hostmask calls.

	* ircd/s_user.c: Update set_hostmask calls aswell as the function
	itself.

2005-07-28  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* README: Small change to test svn mails.

2005-07-20  Alex Schumann  <rubin@afternet.org>

	* ircd/channel.c: Fix : in multi-line bursts. Update comment about
	buffer below.

2005-07-15  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/channel.c: Bump up a buffer.

2005-07-15  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/m_svspart.c: As with the svsjoin commit before, dont use this
	revision yet. Only committing it so i can update my other servers
	easy for testing. Just a few changes.

2005-07-14  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/channel.c: Fixed exempt sending bug, if there are no bans,
	just exempts. Then an channel is bursted like this:
	AS B #rah 1121309805 ANAAD:o :% ~ *!*@exempt.com
	The ircd handles it fine on netbursts as far as i can tell. X2
	also handles it fine, however X3 will need to be changed. As for
	other services, im not sure who else supports nefarious non p10
	exempts.

2005-07-07  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* Changelog.nefarious: Updated CVS_VERSION bits.

	* ircd/version.c.SH: Updated CVS_VERSION bits.

2005-07-07  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/m_svsjoin.c: Few changes, dont use this revision yet. Only
	commiting so that i can update the testnet easily to test this out.

2005-06-23  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* include/client.h: Doxyfy'ed.

	* include/crule.h: Doxyfy'ed.

	* include/dbuf.h: Doxyfy'ed.

	* ircd/client.c: Doxyfy'ed.

	* ircd/crule.c: Doxyfy'ed.

	* ircd/dbuf.c: Doxyfy'ed.

2005-06-23  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* Most taken from Undernet IRCu 2.10.12, of course modified
	where nessecary.

	* include/class.h: Doxyfy class.h.

	* include/IPcheck.h: Doxyfy IPcheck.h.

	* ircd/class.c: Doxyfy class.c.

	* ircd/IPcheck.c: Doxyfy IPcheck.c.

2005-06-21  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* Topic tracking updates and wildcard searching in LIST. Both
	from .12

	* Below By Michael Poole <mdpoole@troilus.org>

	* include/channel.h: Delete MODE_LISTED and is_listed().  Replace
	ListingArgs.chptr with ListingArgs.bucket.  Move declaration of
	list_next_channels() to..

	* include/hash.h: here, and drop the "nr" argument.

	* ircd/channel.c: Remove redundant scan of local clients for
	channels being listed.  Delete list_next_channels() function.

	* ircd/hash.c: Add list_next_channels() here, revising to not use
	MODE_LISTED and to use ListingArgs.bucket instead of chptr.  Also
	decide when to stop sending RPL_LISTs based on a half-full sendq.

	* ircd/m_burst.c, ircd/s_misc.c: Delete mention of MODE_LISTED.

	* ircd/m_list.c: Delete mention of MODE_LISTED.  Unconditionally
	call list_next_channels(sptr).

	* ircd/s_bsd.c: Remove the "nr" argument to list_next_channels().

	* ircd/Makefile.in: Update dependencies (for hash.c).

	* Below By Andrew Miller  <a1kmm@amxl.com>

	* include/channel.h (ListingArgs): Add the wildcard member.

	* ircd/m_list.c (param_parse): Add support for channel wildcards.

	* ircd/m_list.c (show_usage): Document the new format.

	* ircd/hash.c (list_next_channels): Check channel wildcard in list.

2005-06-19  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/s_debug.c: Backported a couple of .12 things for debugging
	and stats purposes.

2005-06-18  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* doc/example.conf: Added new feature EXEMPT_EXPIRE, default set
	to 172800 seconds.

	* include/ircd_features.h: Added FEAT_EXEMPT_EXPIRE.

	* include/ircd_struct.h: Added lastseen to dnsbl exempt list
	struct.

	* include/mark.h: Added new MARK type for sending out updated
	last seen exempt times.

	* ircd/ircd_features.c: Added FEAT_EXEMPT_EXPIRE.

	* ircd/m_exempt.c: Added functions for processing the exempt
	list for updating and expiring where nessecary.

	* ircd/m_mark.c: Do a process_exempts if we get an updated
	last seen time, process_exempts will only do the updating
	bits and not the expiring bit.

	* ircd/s_err.c: Added %Tu to RPL_DNSBLEXEMPTLIST.

	* ircd/s_user.c: Run process_exempts on connect against	a
	clients real host and ip address.

	* ircd/s_serv.c: Send out the lastseen time on burst so all
	servers are in sync.

2005-06-10  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/s_user.c: Small bug fix with MARK's not being sent for
	users who are exempting via class or loc methods (dnsbl scans).

2005-05-09  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* include/querycmds.h: Added conncount.

	* ircd/m_lusers.c: Display conncount with highest connection
	notice.

	* ircd/s_user.c: Increment conncount on each connect.

2005-05-09  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* doc/example.conf: Added feature ERR_OPERONLYCHAN.

	* include/ircd_features.h: Added feature ERR_OPERONLYCHAN.

	* include/ircd_reply.h: Added struct for message formatting.

	* ircd/ircd_features.c: Added feature ERR_OPERONLYCHAN.

	* ircd/ircd_reply.c: Added functions for formatting messages.

	* ircd/m_join.c: Apply formatting for ERR_OPERONLYCHAN.

	* ircd/s_err.c: Turned ERR_OPERONLYCHAN reply to %s.

2005-05-09  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* doc/example.conf: Added rank field to X:Lines.

	* include/client.h: cli_dnsbl holds the highest rank dnsbl,
	cli_dnsbls hold all the dnsbls matched in a char format, and
	cli_sdnsbls is a structure containing all the matched dnsbls.
	cli_dnsbls is generated off this for user in WHOIS.

	* ircd/mark.h: Added MARK_DNSBL_DATA.

	* ircd/s_conf.h: Added rank field into the blline struct.

	* ircd/channel.c: Check all matched dnsbls from the cli_sdnsbls
	struct for bans and exempts.

	* ircd/m_mark.c: Added MARK_DNSBL_DATA so we can send and recieve
	multiple dnsbls, one per send. MARK_DNSBL has been adjusted,
	removing the cli_dnsbl field and the reason field.

	* ircd/m_whois.c: If cli_dnsbls is empty then generate a new list
	from cli_sdnsbls. It will only be empty on a remote server after
	it has linked. Once its generated it will not be generated again.

	* ircd/s_conf.c Added rank field and functions to add, find and
	remove from the cli_sdnsbls struct.

	* ircd/s_err.c: Added rank field to STATSXLINE.

	* ircd/s_misc.c: Clean up the cli_sdnsbls struct on quit.

	* ircd/s_serv.c: Burst MARK_DNSBL and MARK_DNSBL_DATA.

	* ircd/s_stats.c: Added rank field to STATSXLINE.

	* ircd/s_user.c: Generate a cli_dnsbls list and burst MARK_DNSBL
	and MARK_DNSBL_DATA.

2005-05-08  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* doc/example.conf: Added DNSBL d flag for rejecting clients.

	* include/client.h: Added ClearDNSBLAllowed(), Is/SetDNSBLDenied().

	* ircd/s_conf.c: If a client is matched on a line containing a
	d flag then dont allow the client through even if matched on
	another line. We then set the denied flag so that they cant be
	allowed on any further line.

2005-05-05  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/m_invite.c: Some fixes to the invite syntax, needs some
	further testing over multiple servers. If it works out fine then
	i will consider applying it to the 0.4.0 cvs branch.

2005-04-26  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/m_nick.c: Removed code that shouldnt of been added in the
	last commit.

2005-04-25  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* doc/example.conf: Shun F:Lines.

	* doc/readme.shun: readme.gline modified.

	* include/client.h: Shun privs.

	* include/handlers.h: Declerations for m/s_shun etc.

	* include/ircd_features.h: Declerations for added features.

	* include/ircd_struct.h: Added variable to hold the shun reason.

	* include/msg.h: Added SHUN.

	* include/numeric.h: Added numerics for shun.

	* include/shun.c: Declerations.

	* ircd/client.c: Make use of the new privs for shun.

	* ircd/ircd_features.c: Added new features for shun.

	* ircd/m_nick.c: Do a shun check here aslong as the user has
	a host.

	* ircd/m_shun.c: Copy of m_gline.c modified.

	* ircd/Makefile.in: Added m_shun.c && shun.c.

	* ircd/parse.c: For most commands check to see if the user is
	shunned or not. While we are at it to an expiry check too.

	* ircd/s_debug.c: Make some debugging stats avail for shuns.

	* ircd/s_err.c: Added numerics.

	* ircd/s_serv.c: Burst shuns on links.

	* ircd/s_stats.c: Added stats S.

	* ircd/s_user.c: Check shuns on connect && send a notice if so.

	* ircd/shun.c: Main functions for SHUN, based off gline.c with
	nickgline code and minus the channel gline code.


2005-04-25  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* include/patchlevel.h: Bump to 0.5.0-dev.

	* ircd/channel.c: Send who set the topic when bursting topics.

	* ircd/m_topic.c: When a topic comes in with the person who
	set the topic (ms_topic), make sure we make the topic set
	by that person when parsing it. No more not knowing who actually
	set the topic when a server splits and rejoins.

2005-04-19  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* Undernet sync.

2005-04-10  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* include/patchlevel.h: 0.4.0 Release time.. yes seriously.

2005-04-11  Reed Loden  <reed@reedloden.com>

	* ircd/m_invite.c: Fixed crash bug due to a missing parameter 
	for the ERR_ACCOUNTONLY reply.

2005-04-10  Reed Loden  <reed@reedloden.com>

	* configure: Ran autoconf (regenerated).

	* configure.in: Added --with-optimization from .12 and added
	some added AS_HELP_STRING() invokes to clean up ./configure 
	--help.

	* README: Updated documentation.

	* ircd/m_exempt.c: Changed "Removed" to "removed".

	* ircd/version.c.SH: Added missing closing bracket.

2005-04-04  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* configure: regenerated.

	* configure.in: Adjusted the version in preperation for the
	upcomming release. This version on affects configure stuff. Also
	note that this change does not mean Nefarious is released, we
	are just making preperations.

	* README: Small cleanup.

	* README.Cygwin: Important notice added.

	* ircd/version.c.SH: Added Rubin.

2005-04-03  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* doc/readme.log: Added DNSBL Section.

	* include/ircd_log.h: Added DNSBL logging type.

	* ircd/ircd_log.c: See above.

	* ircd/m_exempt.c: Log dnsbl stuff.

	* ircd/m_mark.c: As above.

	* ircd/s_auth.c: As above.

	* ircd/s_conf.c: As above.

	* ircd/s_user.c: As above.

2005-04-02  Reed Loden  <reed@reedloden.com>

	* include/s_auth.h: Added prototypes for DNSReply struct and 
	auth_dnsbl_callback() function (used in ircd/res.c).

	* include/supported.h: Renamed +A to +a.

	* ircd/ircd_features.c: Made the FEAT_OPER_FORCE_OPMODE default 
	to TRUE (people were having a hard time figuring this out).

	* ircd/m_account.c: Performed some miscellaneous whitespacing.
	Removed some unnecessary lines at EOF.

	* ircd/m_mode.c: Fixed a GCC warning and made the logic in an 
	if statement a lot more readable.

	* ircd/m_svsnick.c: Performed some miscellaneous whitespacing.

	* ircd/res.c: Removed unneeded prototype now that it is
	handled in include/s_auth.h (where it should have been done
	earlier). Performed some miscellaneous whitespacing.

	* ircd/s_conf.c: Performed some miscellaneous whitespacing and
	grammatical changes.

2005-04-03  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* include/client.h: Added ClearDNSBLMarked().

	* ircd/s_user.c: If a user has loc'ed and is marked then skip
	marking their host and unmark them. Their normal hidden host
	(style 1) should kick in and work fine.

2005-04-01  Alex Schumann  <rubin@afternet.org>

	* doc/example.conf: added F:EXTENDED_ACCOUNTS

	* doc/readme.features: added F:EXTENDED_ACCOUNTS

	* ircd/m_account.c: Redid m_account() to move backward compatability
	code to an F line. The old way was overrunning the parv array. Added
	tons of protocol validity checks.

	* ircd/m_mode.c: Fixed a core when +k users set bans. Thanks to
	Jaden for discovering this on the production net... :/

2005-03-31  Alex Schumann  <rubin@afternet.org>

	* ircd/m_account.c: check for null in decode_auth_id
	(crash on pLaYa's net)

2005-03-31  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/channel.c: Fixed a bug with style 2 and banning sethost
	users. Also applied to exempts.

	* ircd/s_conf.c: Few unused vars removed.

2005-03-29  Alex Schumann  <rubin@afternet.org>

	* ircd/ircd_alloc.c: remove test code never ment to be 
	committed.

	* ircd/res.c: do not cache certain types of ip aliases
	when the lookup is for an rbl. This appears to solve
	the false positives with sorbs. (and added): Also dont find them either.
	The cache appears to be working right now. gonna upgrade afternet.

	* ircd/s_conf.c: Rewrite of find_blline from nearly scratch.
	not yet well tested but committed to put on air* and look at.

	* ircd/s_conf.c: tested all but the bitmap part, and here
	made it work.

	* ircd/ssl.c: added EBUSY and EAGAIN to errno's not to die on.

2005-03-30  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/s_auth.c: Woops changed the wrong one.

	* ircd/s_conf.c: Turn dhname strtok loop into a strtok_r loop.
	Also turned dhname into a normal char.

2005-03-30  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/m_svsnick.c: Bug fix: NICK was being sent twice to users.

2005-03-30  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/s_auth.c: Turned a static char into a normal char.

	* ircd/s_conf.c: Bug fix with S:Lines.

	* ircd/s_err.c: Bug fix with S:Lines (reeds fault).

	* ircd/ssl.c: Couple of lines moved so it will compile.

2005-03-28  Alex Schumann  <rubin@afternet.org>

	* ircd/s_auth.c: reformatted some stuff so i could read it. Trying
	to figure out why RBL stuff is so broken :/

	* ircd/s_conf.c: Several conf line clear_* functions were freeing
	memory but not re-terminating the global head. Someone please look
	at this and tell me if im missing something...

2005-03-27  Alex Schumann  <rubin@afternet.org>

	* ircd/s_bsd.c: Applied a connection fix from .12 may help ssl

	* ircd/ssl.c: Save errno before Debug() calls.

2005-03-28  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/querycmds.c: Fixed the reading of the tune file, LUSERS will
	come out properly now.

2005-03-26  Reed Loden  <reed@reedloden.com>

	* include/numeric.h: Swap RPL_STATSSLINE to numeric 245
	(other IRCds use this).

	* ircd/m_oper.c: Renamed +A to +a.

	* ircd/s_err.c: Renamed +A to +a.

	* ircd/s_user.c: Renamed "b:line" to "B:line" in a comment.

2005-03-26  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/channel.c: Dont destroy channels when -z is removed for
	now. If your wondering why drop into #evilnet. Its a complicated
	issue that there isnt an easy way to solve it at the moment.

2005-03-23  Reed Loden  <reed@reedloden.com>

	* .cvsignore: Revert inadvertent addition of configure to 
	the cvsignore list.

	* include/ircd_features.h: Renamed FEAT_CHMODE_A to
	FEAT_CHMODE_a.

	* ircd/channel.c: Renamed MODE_ADMINONLY from +A to +a.
	Performed some miscellaneous whitespacing and
	grammatical changes.

	* ircd/ircd_features.c: Renamed FEAT_CHMODE_A to
	FEAT_CHMODE_a.

	* ircd/ircd_signal.c: Removed excess lines at EOF.

	* ircd/m_account.c: Fixed a bug where if the account name began 
	with 'M' or 'U', bad things would happen (only if 
	sending service does not support LOC). == should have been !=.
	:/

	* ircd/m_burst.c: Renamed MODE_ADMINONLY from +A to +a.

	* ircd/m_clearmode.c: Added MODE_ADMINONLY to the list of modes 
	to be cleared.

	* ircd/m_exempt.c: Miscellaneous whitespacing and grammatical
	changes.

	* ircd/m_join.c: Renamed MODE_ADMINONLY from +A to +a.

	* ircd/m_mark.c: Miscellaneous whitespacing and grammatical
	changes.

	* ircd/map.c: Removed excess lines at EOF.

	* ircd/s_stats.c: Fixed a bug that was causing FEAT_STATS_C_IPS
	not to work.

	* ircd/s_user.c: Renamed MODE_ADMINONLY from +A to +a.

2005-03-22  Alex Schumann   <rubin@afternet.org>

	* ircd/s_user.c: Dont send null host in mark, send "notmarked" to 
	keep param count right. ..now with works!

	* ircd/s_serv.c: Dont send null host in mark, send "notmarked" to
	keep param count right. ...now with works!

2005-03-23  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/channel.c: Ok -z is hopefully fixed now.

	* ircd/m_mode.c: If you are using mode_parse it could result in
	a destroy_unregistered_channel if you are doing a -z.

2005-03-22  Alex Schumann   <rubin@afternet.org>

	* ircd/channel.c: sv: You cant destroy that chptr its used more
	down farther in that function... (as state.chptr)

	* ircd/m_mark.c: fixed some parv confusion

	* ircd/s_conf.c: added an assert for flags

	* ircd/s_user.c: properly initalise flagbuf.

2005-03-22  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/channel.c: Fixed a small issue with -z'ing an empty channel. 
	(Non crash bug). Wont know for sure till the rest of the test net is
	updated, currently ive done testing with 2 servers seperatly and the
	bug is fixed.

2005-03-22  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/channel.c: Added a missing check for persist (doesnt fix a known
	non critical bug)

	* ircd/m_mark.c: Added a %s to CMD_MARK.

	* ircd/s_user.c: Added a %s to CMD_MARK.

2005-03-21  Alex Schumann  <rubin@afternet.org>

	* ircd/s_conf.c: attempting to fix crash bug

2005-03-14  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/m_exempt.c: Small fix.

2005-03-14  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/s_user.c: Added NICKLEN to the inital length of host and ip
	check for dnsbl exempts. Changed HOSTLEN to SOCKIPLEN for the ip
	mask.

2005-03-14  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/m_exempt.c: Needed changes for our web exempt module. Send notices
	if the exemption is already there when adding or isnt there when trying to
	remove move it. Also fixed a bug with syncing exempts when removing them.

	* ircd/s_user.c: Check both nick!user@host and nick!user@ip for
	exemptions as apache doesnt usually resolve hosts so it will be giving
	us ips in the exemption module on the website.

2005-03-11  Reed Loden  <reed@reedloden.com>

	* include/patchlevel.h: Changed 0.3.0 to 0.4.0-dev so as not to
	confuse people that can't see why the tarball is different from
	CVS.

	* ircd/Makefile.in: Ran "make depend".

	* ircd/ircd_relay.c: Swapped a strlen() check for the
	EmptyString() macro.

	* ircd/m_account.c: Added UserStats.authed incrementer
	(moved from s_user.c).

	* ircd/s_auth.c: Cleaned-up some whitespacing.

	* ircd/s_user.c: Corrected a spelling typo and removed broken
	UserStats.authed incrementer.

2005-03-03  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/ircd_relay.c: If a stripped message (+S) is 0 in length
	then dont send it. Found by pLaYa.

2005-03-02  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/s_conf.c: Added some sanity checks.

2005-03-01  Alex Schumann  <rubin@afternet.org>

	* ircd/ssl.c: Added some Debug() info to try and track down
	the Write error: 0 during netsplit bug for ssl users.

2005-03-01  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/s_user.c: Dont display RPL_HOSTHIDDEN if we are setting the
	dnsblhost.

2005-03-01  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/m_fakehost.c: Allow any server to set a fakehost.

	* ircd/m_mark.c: Search for a nick now, also send a nickname now.

	* ircd/s_serv.c: Send a nickname in MARK.

	* ircd/s_user.c: Any marking commands are to be done after the N token!
	Send +x's to the client and other servers so that they hide the clients
	host with the dnsblhost. Send a nickname in MARK.

2005-03-01  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/m_account.c: Temp debugging stuff.

	* ircd/m_mark.c: Temp debugging stuff.

	* ircd/s_user.c: Adjusted CMD_MARK some wierdness going on here.

2005-03-01  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/m_mark.c: Handle new parm plus send out MARK to any other servers.

	* ircd/s_user.c: Send the dnsblhost along to other servers.

	* ircd/s_serv.c: Send the dnsblhost along to other servers.

2005-03-01  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

        * ircd/Makefile.in: Ran make depend.

2005-02-28  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* doc/example.conf: Added new feature DNSBL_MARK_FAKEHOST. Default
	TRUE. When true a client who has been marked will get their dnsbl
	host placed in their fakehost.

	* include/ircd_features.h: Added FEAT_DNSBL_MARK_FAKEHOST.

	* ircd/ircd_features.c: Added DNSBL_MARK_FAKEHOST.

	* ircd/m_account.c: If a client is marked, if they have a fakehost
	set, if their fakehost matches their dnsbl host, and if
	DNSBL_MARK_FAKEHOST is enabled then ClearFakeHost when a valid
	account is set. Clients can then use normal host hiding. They
	can still be banned via dnsblname.host.com in channels.

	* ircd/s_user.c: Set the dnsblhost to the fakehost and enable
	it and hide the user if DNSBL_MARK_FAKEHOST is TRUE/

2005-02-28  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

        * ircd/m_exempt.c: If we are recieving new exemptions during a
	netburst then dont spit out notices over adding.. this could
	cause a large flood. (nb = netburst, nm = normal).

	* ircd/s_serv.c: send along nb on the end of a cmd_exempt when
	bursting exemptions.

2005-02-28  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* include/handlers.h: Added new handlers for exempt command.

	* include/ircd_struct.h: Structure for exemptions plus a function
	decleration.. keeping it here with the exemption structure.

	* include/msg.h: Added stuff for EXEMPT command.

	* include/numeric.h: Two new numerics for exemption listing.

	* ircd/Makefile.in: Added m_exempt.c.

	* ircd/m_exempt.c: New file, opers can now add exemptions.

	* ircd/parse.c: EXEMPT command stuff.

	* ircd/s_err.c: Numeric stuff.

	* ircd/s_serv.c: Burst exempts on links.

	* ircd/s_user.c: Mark a client if they are exempted and let
	them in.

2005-02-27  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* configure: Regenerated.

	* configure.in: Stop configure if the user doesnt have SSL when
	trying to enable it.

	* doc/Configure.help: Removed, old.

	* doc/exaconf.2: Removed, not in use.

	* doc/iauth.txt: Removed, not in use.

	* doc/linux-poll.patch: Removed, old.

	* doc/readme.cvs: Updated with our cvs information.

	* doc/readme.indent: Removed, not needed.

	* doc/readme.www: Removed, not needed.

2005-02-26  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

        * ircd/m_whois.c: Display dnsbl status even if its disabled on the
	local server.

2005-02-25  Reed Loden  <reed@reedloden.com>

	* ChangeLog.nefarious: Cleaned-up Rubin's ChangeLog entry.

	* include/s_conf.h: Added GlobalBLCount global (from s_misc.h).

	* include/s_misc.h: Removed bllinecount global.

	* ircd/m_nick.c: Somewhat alphabetized #include list.

	* ircd/m_svsnick.c: Added #include "gline.h" to fix a warning
	when using NICKGLINES.

	* ircd/parse.c: Use QuakeNet's methodology when dealing with
	MFLG_SLOW (puts some checks on what the oper is doing).

	* ircd/s_auth.c: Renamed bllinecount to GlobalBLCount.

	* ircd/s_conf.c: Renamed bllinecount to GlobalBLCount (and used
	it!).

2005-02-25  Alex Schumann  <rubin@afternet.org>

	* ircd/s_auth.c: Add check for IsDNSPending(auth) in addition
	to IsDoingAuth(auth) before freeing auth.

2005-02-25  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/s_auth.c: Couple of debug statements so the if statements
	are worthwhile.

2005-02-25  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/s_auth.c: Don't decrement in the loop where we check for
	multiple ips in the reply; do it before.
	Implemented .12's header code.. much simpler.
	Also added another reply for dnsbls.

2005-02-24  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/s_auth.c: Check every dnsbl.

	* ircd/s_conf.c: If the client has already been marked return 1.

2005-02-24  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/client.h: Added a count to the client struct for counting
	down dnsbls as we scan through them on connect.

	* ircd/s_misc.h: Global int for the total amount of X:Lines. This
	is updated on start and rehashes.

	* ircd/s_auth.c: Set the client dnsbl pending for the whole scan
	then count down the total in the client struct till it reaches 0.
	Once its 0 we are able to release the client auth safely and are
	able to clear dnsbl pending.

	* ircd/s_conf.c: Update bllinecount on start and rehash.

2005-02-23  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/s_conf.c: Somehow find_blline was being called with missing
	parameters, the results were quite nasty.

2005-02-22  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/s_serv.c: We only want to send dnsbl info to the linking
	server.

	* ircd/s_user.c: Send MARK from the server not the client.

2005-02-21  Reed Loden  <reed@reedloden.com>

	* ircd/s_err.c: Oops, forgot to remove the old entries.

2005-02-21  Reed Loden  <reed@reedloden.com>

	* ChangeLog.nefarious: Redid Rubin's ChangeLog entry.

	* config.h.in: Ran autoheader.

	* configure: Regenerated through autoconf.

	* configure.in: Redid humor stuff and removed second -lssl.

	* include/client.h: Miscellaneous whitespacing changes.

	* include/msg.h: Miscellaneous whitespacing changes.

	* include/numeric.h: Renumbered some of the RULES numerics.
	Miscellaneous whitespacing changes.

	* ircd/Makefile.in: Correctly alphabetized m_wallvoices.c and
	ran make depend.

        * ircd/channel.c: Added nu_dnsblhoste and renamed sfd to sde in
        ban exemptions. Added nu_dnsblhost to is_banned(). Swapped DNSBL 
	checks to use the added variables.

	* ircd/engine_epoll.c: Change a size_t to socklen_t to match
	getsockopt prototype, so it compiles without warning on amd64
	(Backported from u2.10.12).

	* ircd/s_err.c: Renumbered some of the RULES numerics.

2005-02-21  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* config.h.in: Removed KEY defines.

	* configure: Regenerated.

	* configure.in: Removed cloak key stuff.

	* include/ircd_defs.h: Define the cloak keys here now.

	* ircd/hosthiding.c: Removed some defines. Keeping the random
	number function for now.

2005-02-21  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* doc/example.conf: Updated X:Lines with new flags/name bits.

	* include/client.h: Added 2 new flags for dnsbl's for marking
	and allowing clients.  Added junk for X:Line flags also.

	* include/handlers.h: Added define for ms_mark.

	* inclide/ircd_struct.c: Added dnsblhost entry to the client
	struct.

	* include/mark.h: New file, just general mark stuff.

	* include/msg.h: Added stuff for the new MARK command.

	* include/numeric.h: Added new numeric RPL_WHOISDNSBL (339).

	* include/s_conf.c: Adjusted blline struct for flags and name
	support.

	* ircd/Makefile.in: Added m_mark.c.

	* ircd/channel.c: Check the dnsblhost for banning and excepting.

	* ircd/m_mark.c:  New command, used for marking clients on 
	remote servers with information. In this case DNSBL information.

	* ircd/m_whois.c: Do something with RPL_WHOISDNSBL.

	* ircd/parse.c: Added MARK command.

	* ircd/s_conf.c: Properly handle dnsbl flags and the new name
	bit. Set the right flags on clients if we needed to.

	* ircd/s_err.c: Updated the stats reply line for X:lines. Also
	added RPL_WHOISDNSBL.

	* ircd/s_serv.c: Burst dnsbl information with MARK.

	* ircd/s_stats.c: Updated the stats reply line for X:lines.

	* ircd/s_user.c: Mark the client hostname if nessecary. If the client
	is allowed then also let them in even if they are on a dnsbl. Also
	send out a MARK to all servers.

2005-02-18  Reed Loden  <reed@reedloden.com>

	* config.h.in: Ran autoheader.

	* configure: Ran autoconf.

	* configure.in: Backported va_copy checks from u2.10.12.

	* include/ircd_features.h: Renamed FEAT_LOC_DEFAULT_NICK to
	FEAT_LOC_DEFAULT_SERVICE.

	* include/ircd_snprintf.h: Added backported va_copy #ifdefs.

	* ircd/ircd_features.c: Renamed FEAT_LOC_DEFAULT_NICK to
	FEAT_LOC_DEFAULT_SERVICE.

	* ircd/m_oper.c: Miscellaneous whitespacing changes.

	* ircd/m_pass.c: Renamed FEAT_LOC_DEFAULT_NICK to
	FEAT_LOC_DEFAULT_SERVICE. Miscellaneous whitespacing changes.

2005-02-18  Alex Schumann  <rubin@afternet.org>	

	* include/ircd_features.h: Added FEAT_LOC_DEFAULT_NICK.

	* ircd/ircd_features.c: Added FEAT_LOC_DEFAULT_NICK (default:
	"AuthServ").

	* ircd/m_pass.c: Added improved login-on-connect syntax and
	fixed a bug.

2005-02-11  Reed Loden  <reed@reedloden.com>

	* config.guess, config.sub: Synched to timestamp 2005-02-10.

	* ircd/engine_kqueue.c, ircd/fileio.c, ircd/ircd_log.c,
	ircd/send.c: Backport of FreeBSD 5.3 fixes from u2.10.12.

	* ircd/m_svsnoop.c: Removed unnecessary #include for
	ircd_features.h.

	* ircd/s_user.c: Synched with QuakeNet +kX patch (+X now allows
	oper to change nick while banned in a channel).

2005-02-10  Reed Loden  <reed@reedloden.com>

	* include/ircd_features.h: Removed FEAT_MOTD_LAST_CHANGED due to
	problems.

	* ircd/gline.c: Backport of u2.10.12 fix for problem when
	glining +TEST instead of +*@TEST. Part of fix is originally from
	QuakeNet Asuka.

	* ircd/ircd_features.c: Removed FEAT_MOTD_LAST_CHANGED due to
	problems.

	* ircd/m_endburst.c: If the channel has already been "nuked", we
	can't remove a mode from it. This was found when using
	ElectricFence and has yet to be reported to Undernet.

	* ircd/m_fakehost.c: Cleaned up code and removed unnecessary
	brackets.

	* ircd/m_invite.c: +R (AccountOnly) now stops unauthed users
	from inviting people that have umode +R set. Patch from
	QuakeNet.

	* ircd/m_kick.c: Fixed a warning due to missing parentheses.

	* ircd/m_mode.c: Fixed a warning due to uninitialized variable.

	* ircd/m_svsjoin.c: Cleaned up code (optimized a bit) and
	removed the check for check_target_limit() as it is for local
	clients only and does not apply to us.

	* ircd/m_userip.c: Synched with QuakeNet HIS_USERIP patch.

	* ircd/motd.c: Removed offending code that caused problems when
	running ElectricFence. This removes FEAT_MOTD_LAST_CHANGED.

	* ircd/s_conf.c: Synched with QuakeNet sethost patch (allows IP
	addresses to be wildcarded).

	* ircd/s_user.c: Removed code concerning FEAT_MOTD_LAST_CHANGED.

	* ircd/whocmds.c: Synched with QuakeNet HIS_USERIP patch.

2005-01-31  Reed Loden  <reed@reedloden.com>

	* include/client.h: Added new FLAG_WHOIS (+W) aka
	WHOIS_PARANOIA. Cleaned up some whitespacing.

	* include/supported.h: Added +W to usermode list.

	* include/ircd_features.h: Added FEAT_OPER_WHOIS_PARANOIA.

	* ircd/channel.c: Changed a comment.

	* ircd/ircd_features.c: Added FEAT_OPER_WHOIS_PARANOIA
	(default: FALSE)

	* ircd/m_whois.c: Implemented FEAT_OPER_WHOIS_PARANOIA under the 
	SeeOper() if check.

	* ircd/s_user.c: Added FLAG_WHOIS (+W) and gave
	FEAT_OPER_WHOIS_PARANOIA control over it.

2005-01-31  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/channel.c: Trash excepts when destroying channels (+z).

2005-01-30  Reed Loden  <reed@reedloden.com>

	* include/channel.h: Added a comment for MODE_PERSIST.

	* include/s_conf.h: Cleaned up whitespacing.

	* ircd/channel.c: Moved MODE_PERSIST. Cleaned up whitespacing.
	Cleaned up some MODE_PERSIST code as to fend off future
	problems.

	* ircd/ircd_features.c: Removed FEAT_READ from
	FEAT_LUSERS_AUTHED.

	* ircd/m_oper.c: Cleaned up whitespacing.

	* ircd/s_misc.c: Removed check for FEAT_LUSERS_AUTHED.

	* ircd/s_user.c: Removed check for FEAT_LUSERS_AUTHED. Changed a
	hardcoded 512 to BUFSIZE.

2005-01-30  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* doc/example.conf: Added b:lines (lowercase b) for prefix'ed
	commands to be redirected to the specified server. Stats b
	F:Line added also but not in use yet.

	* include/channel.h: Added MODE_PERSIST (+z).

	* include/ircd_features.h: Fixed a bug in the F:lines. Added
	stats b F:line.

	* include/numeric.h: Numeric for stats b.

	* include/s_conf.h: GlobalForwards decleration.

	* include/send.h: sendcmdto_channel_butone adjusted to support
	a prefix.

	* ircd/channel.c: Handle MODE_PERSIST.

	* ircd/ircd_features.c: Added stats b F:Line.

	* ircd/ircd_relay.c: Updated sendcmdto_channel_butone usage.

	* ircd/m_endburst.c: Add empty channels which contain +z.

	* ircd/m_kick.c: No change really just the same as .12.

	* ircd/m_mode.c: No change really just the same as .12.

	* ircd/m_wall*.c (except m_wallops.c): Updated sendcmdto_channel_butone
	usage.

	* ircd/s_conf.c: Read and handle b:lines.

	* ircd/s_err.c: Added numeric for stats b.

	* ircd/s_numeric.c: Updated sendcmdto_channel_butone usage.

	* ircd/send.c: Updated main sendcmdto_channel_butone to look
	for prefix's and foward messages if needed.

2005-01-29  Reed Loden  <reed@reedloden.com>

	* include/ircd_features.h: Added FEAT_CHMODE_Z and
	FEAT_LUSERS_AUTHED.

	* include/querycmds.h: Added UserStats.authed for stats on all
	authenticated (IsAccount()) users.

	* include/supported.h: Added some checks for the halfops stuff.
	Added Z to the list of chmodes.

	* ircd/channel.c: Renamed MODE_SSLONLY (orig +z) to +Z. +z will 
	now become MODE_PERSIST (from GameSurge).

	* ircd/ircd_features.c: Marked FEAT_HALFOPS, FEAT_EXCEPTS, and
	FEAT_BREAK_P10 as FEAT_READ (read-only feature). Added
	FEAT_CHMODE_Z (default: TRUE) and FEAT_LUSERS_AUTHED
	(read-only feature with default: FALSE).

	* ircd/m_burst.c: Renamed MODE_SSLONLY (orig +z) to +Z. 
	Put uppercase modes in alphabetical order.

	* ircd/m_clearmode.c: Renamed MODE_SSLONLY (orig +z) to +Z.

	* ircd/m_ircops.c: Removed unneeded reply. Swapped out some
	commented code for remote IRCOPS (not yet used).

	* ircd/m_join.c: Renamed MODE_SSLONLY (orig +z) to +Z.
	Put uppercase modes in alphabetical order.

	* ircd/m_lusers.c: Added support for an alternate form of the
	/LUSERS reply as requested by Rubin (RFE 1112215). Instead of 
	showing invisible clients, authed (+r) clients are now shown.
	This, of course, is default FALSE with FEAT_LUSERS_AUTHED.

	* ircd/m_oper.c: Cleaned up whitespacing. Added comment.

	* ircd/s_debug.c: Renamed the USE_SSL notifier ('z') to 'Z'.

	* ircd/s_err.c: Allowed the word "invisible" to be dynamically
	changed (now a variable -- %s).

	* ircd/s_misc.c: Added support for the new FEAT_LUSERS_AUTHED.

	* ircd/s_user.c: Added support for the new FEAT_LUSERS_AUTHED.

	* ircd/version.c.SH: Updated copyright date to 2002-2005.

2005-01-28  Reed Loden  <reed@reedloden.com>

	* include/supported.h: Reordered modes (specifically admin [A]).

	* ircd/channel.c: Removed broken code and replaced it with
	boring, but working!, code. Cleaned up whitespacing.

	* ircd/m_oper.c: Changed default snomask for admin back to
	normal oper default.

	* ircd/m_swhois.c: Removed parameter checking as it is
	unnecessary. Correctly forward swhois messages.

	* ircd/s_serv.c: Burst swhois messages.

	* ircd/send.c: Updated file location.

2005-01-28  Reed Loden  <reed@reedloden.com>

	* include/ircd_features.h: Added FEAT_HIS_USERIP.

	* ircd/channel.c: Commented out broken code (I'll fix it
	sometime; sorry y'all).

	* ircd/ircd_features.c: Added FEAT_HIS_USERIP (default: FALSE).

	* ircd/m_check.c: Fixed several warnings in new QuakeNet code.

	* ircd/m_invite.c: Added invite timestamps (from u2.10.12).
	Removed duplicate code.

	* ircd/m_userip.c: Added HIS_USERIP from QuakeNet.

	* ircd/s_err.c: Added RPL_WHOISSPECIAL (320).

2005-01-28  Neil Spierling <sirvulcan@sirvulcan.co.nz>

	* ircd/m_oper.c: Switched a couple of things.

2005-01-27  Reed Loden  <reed@reedloden.com>

	* doc/example.conf: Removed FEAT_DISALLOW_CHMODE_L. The new
	features have yet to be added.

	* include/client.h: Added PRIV_REMOTEREHASH, PRIV_CHECK, and 
	PRIV_SEE_SECRET_CHAN. Renamed OpIsGlobal/OpIsAdmin to
	OIsGlobal/OIsAdmin.

	* include/handlers.h: Added ms_swhois handler.

	* include/ircd_features.h: Added FEAT_SWHOIS and FEAT_CHMODE_*. 
	Renamed FEAT_DNSBL_TEST_N_WALLOP to FEAT_DNSBL_WALLOPS_ONLY.
	Removed FEAT_DISALLOW_CHMODE_L.

	* include/ircd_struct.h: Added pointer to swhois message.

	* include/msg.h: Added SWHOIS token (SW).

	* include/numeric.h: Added RPL_WHOISSPECIAL (320).

	* ircd/Makefile.in: Added m_swhois.c and ran make depend.

	* ircd/channel.c: Removed FEAT_DISALLOW_CHMODE_L and added
	support for the new FEAT_CHMODE_* stuff.

	* ircd/client.c: Added PRIV_REMOTEREHASH, PRIV_CHECK, and
	PRIV_SEE_SECRET_CHAN. Cleaned up whitespacing.

	* ircd/ircd_features.c: Added FEAT_SWHOIS and FEAT_CHMODE_*. 
	Renamed FEAT_DNSBL_TEST_N_WALLOP to FEAT_DNSBL_WALLOPS_ONLY.
	Removed FEAT_DISALLOW_CHMODE_L.

	* ircd/m_check.c: Swapped a feature check to a privilege check.

	* ircd/m_ircops.c: Changed to a hybrid format for /IRCOPS 
	output.

	* ircd/m_links.c: Fixed a bug in which FEAT_HIS_LINKS_SCRAMBLED 
	was not being considered. Thanks to Protium (CaptKirk`/Maximus)
	for finding this.

	* ircd/m_mode.c: Cleaned up whitespacing.

	* ircd/m_oper.c: Attempted to clean-up code. I think there are 
	problems with this code, so it needs a second look.
	One thing: Why is SetRemoteOper() called AFTER 
	client_set_privs()?

	* ircd/m_rehash.c: Implemented PRIV_REMOTEREHASH.

	* ircd/m_set.c: Cleaned up whitespacing.

	* ircd/m_svsjoin.c: SVSJOIN now calls m_join().

	* ircd/m_svspart.c: Cleaned up whitespacing.

	* ircd/m_swhois.c: Added SWHOIS support (new file).

	* ircd/m_whois.c: Cleaned up whitespacing. Moved around some
	replies. Implemented SWHOIS. Implemented PRIV_SEE_SECRET_CHAN.

	* ircd/parse.c: Added SWHOIS support.

	* ircd/s_conf.c: Cleaned up whitespacing. Optimized code.
	Removed unnecessary variables (were causing warnings).

	* ircd/s_user.c: Added SWHOIS support. Cleaned up whitespacing.
	Optimized code. Fixed a potential core bug (sptr -> acptr).
	Renamed FEAT_DNSBL_TEST_N_WALLOP to FEAT_DNSBL_WALLOPS_ONLY.

2005-01-28  Neil Spierling <sirvulcan@sirvulcan.co.nz>

	* include/check.h: Quakenet updates, flags added.

	* ircd/gline.c: Quakenet updates, few nick gline changes.

2005-01-28  Neil Spierling <sirvulcan@sirvulcan.co.nz>

	* doc/example.conf: Changed RECORD to REPLY for X:Lines.

	* include/ircd_features.h: Added an undocumented F:Line for testing
	the new DNSBL stuff (FEAT_DNSBL_TEST_N_WALLOP).

	* ircd/ircd_features.c: See above.

	* ircd/s_conf.c: Make use of the new line, send a wallop if an
	connecting client is listed on an dnsbl set in the X:Lines.

2005-01-28  Neil Spierling <sirvulcan@sirvulcan.co.nz>

	* doc/example.conf: Updated X:Lines entry.

	* ircd/s_conf.c: Only check the last octet of the ip.
			 Added support for comma seperate replies for RECORD replies.
			 General cleanup, removed debugging stuff.

2005-01-26  Neil Spierling <sirvulcan@sirvulcan.co.nz>

	* doc/example.conf: Updated X:Lines for type support.
                            Added in F:Lines for dnsbl loc rejection notices.

	* include/ircd_features.h: Added DNSBL_LOC_EXEMPT_N_ONE and
	DNSBL_LOC_EXEMPT_N_TWO.

	* include/s_conf.h: Added type to blline struct.

	* ircd/ircd_features.c: Same as ircd_features.h.

	* ircd/s_conf.c: Added support for Bitmask dnsbl's.

	* ircd/s_err.c: Extended RPL_STATSXLINE so that the type can be
	displayed.

	* ircd/s_stats.c: See above.

	* ircd/s_user.c: Make use of the two new features.

2005-01-24  Neil Spierling <sirvulcan@sirvulcan.co.nz>

	* ircd/m_ircops.c: Differ between irc admins and irc operators
	in the output.

2005-01-24  Neil Spierling <sirvulcan@sirvulcan.co.nz>

        * doc/example.conf: Added missing REMOTE_OPER.

	* ircd/ircd_relay.c: Extended ERR_CANNOTSENDTOCHAN replies to
	include a reason for some replies.

	* ircd/m_oper.c: Implemented remote oper for admins.

	* ircd/m_topic.c: ERR_CANNOTSENDTOCHAN extension.

	* ircd/m_wallchops.c: ERR_CANNOTSENDTOCHAN extension.

	* ircd/m_wallhops.c: ERR_CANNOTSENDTOCHAN extension.

	* ircd/m_wallvoices.c: ERR_CANNOTSENDTOCHAN extension.

	* ircd/s_err.c: Allow extra information to be added to
	ERR_CANNOTSENDTOCHAN.

2005-01-24  Neil Spierling <sirvulcan@sirvulcan.co.nz>

	* ChangeLog.nefarious: Hey its jan not decemeber :).

	* doc/example.conf: Added DISALLOW_CHMODE_L to prevent normal users
	using the mode. Default FALSE

	* ircd/channel.c: Allow servers to set exempts even if disabled,
	prevents desyncs. Disallow channel mode +L to normal users.

	* include/ircd_features.h: Same as example.conf.

	* ircd/ircd_features.c: Same as example.cinf.

2005-01-20  Neil Spierling <sirvulcan@sirvulcan.co.nz>

	* doc/example.conf: Dropped DNSBL_LOC, merged with DNSBL_LOC_EXEMPT.

	* include/ircd_features.h: Same as above.

	* ircd/ircd_features.c: Same as above.

	* ircd/s_user.c: Same as above. Also fixed a small issue with
	users still being prompoted for their authserv details after
	they successfully auth with LOC.

2005-01-20  Neil Spierling <sirvulcan@sirvulcan.co.nz>

	* doc/example.conf: Added new feature DNSBL_LOC. If enabled
	along with LOGIN_ON_CONNECT, anyone matching on a DNSBL will be
	given a chance to bypass being rejected by logging into the
	services via login on connect. Im tempted to combine this with
	DNSBL_LOC_EXEMPT.

	* include/ircd_features.h: Added FEAT_DNSBL_LOC.

	* ircd/ircd_features.c: Added DNSBL_LOC, default FALSE.

	* ircd/s_user.c: Added code for DNSBL_LOC. See example.conf
	entry above for what it does. The notice will be F:Lined
	later most likely.

2004-12-16  Reed Loden  <reed@reedloden.com>

	* include/channel.h: Removed the MyConnect() restraint from 
	IsSSL() as it is no longer needed.

	* ircd/channel.c: Fixed compile error and hopefully corrected 
	(for the final time) the annoying +z permission denied bug.

	* ircd/m_rehash.c: Added SSL pem reopening support where it was
	missing and restricted special commands to one character server
	names only.

	* ircd/s_conf.c: Reopen the SSL pem file on rehash.

2004-12-15  Reed Loden  <reed@reedloden.com>

	* configure: Ran autoconf.

	* configure.in: Added base for what will later become checks for
	gnuTLS.

	* include/channel.h: Added prototype for SetAutoChanModes() and 
	commented on the MODE_PARSE_ISHALFOP define.

	* include/ircd_features.h: Added FEAT_AUTOINVISIBLE.

	* include/ssl.h: Added base for what will later become options 
	for different SSL programs (OpenSSL/gnuTLS/etc.).

	* ircd/channel.c: Fixed a bug in the ban code in which halfops
	could not set bans and fixed a bug in +z/+O/+A code in which
	services (+k) could not set +z/+O/+A (thanks Maximus@Protium).

	* ircd/ircd_features.c: Added FEAT_AUTOINVISIBLE
	(default: FALSE) from QuakeNet.

	* ircd/m_create.c: Don't allow a client to join a channel
	multiple times (patch from Entrope).

	* ircd/m_join.c: More work from QuakeNet on AutoChanModes 
	(added SetAutoChanModes() to run when someone creates a chan).

	* ircd/m_mkpasswd.c: Moved ':' to correct location
	(found by Rubin).

	* ircd/s_err.c: Add "BADCHAN:" to ERR_BADCHANNAME notice and
	added patch from QuakeNet to make error messages more friendly.

	* ircd/s_user.c: Optimized code, cleaned up whitespacing, and
	added FEAT_AUTOINVISIBLE (from QuakeNet asuka).

2004-12-15  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

        * doc/example.conf: Updated X:Line entry.

	* ircd/s_auth.c: Use hname instead of the host from the host to
	ip reply. Debugging stuff added also.

	* ircd/s_conf.c: Only support one reply per X:Line, temp fix for
	now. Damn entries list would get truncated after the first read.
	Tried everything to get around it being truncated. Debugging
	stuff added also.

2004-12-10  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* doc/example.conf: Added OPER_WHOIS_SECRET.

	* include/client.h: Added ClearAccount().

	* include/ircd_features.h: Added FEAT_OPER_WHOIS_SECRET.

	* include/s_user.h: Added unhide_hostmask().

	* ircd/ircd_features.c: Added OPER_WHOIS_SECRET, default TRUE.

	* ircd/m_account.c: Added two new flags. M for renaming an
	account (AZ AC AZAAA M newaccount). And U for removing an
	account (AZ AC AZAAA U).

	* ircd/m_whois.c: If OPER_WHOIS_SECRET is TRUE then show +s
	channels for opers.

	* ircd/s_user.c: Added unhide_hostmask to unhide an account
	based hidden host. Works with Account removal.

2004-11-20  Reed Loden  <reed@reedloden.com>

	* ircd/channel.c (SetAutoChanModes): Fixed a warning in
	QuakeNet's code by casting (int)chan_flags to (unsigned int*).

2004-11-19  Reed Loden  <reed@reedloden.com>

	* configure.in: Changed AC_PREREQ's dnl to correctly say '2.57'.

	* include/channel.h: Changed the order of the memory locations.

	* ircd/gline.c: Incorporated fix from QuakeNet in gline_list()
	(vulcan already had it semi-fixed, but just not completely).

	* ircd/ircd_features.c: Changed FEAT_ANNOUNCE_INVITES default
	to FALSE.

	* ircd/m_server.c: Removed unnecessary assignment of 'host'.

	* ircd/m_whois.c: Fixed problem where opers could see all +s
	channels in WHOIS (opers get too curious/lazy; use services!),
	did miscellaneous whitespacing changes, and some optimizations.

	* ircd/s_conf.c: Fixed problem where the C:line name was being
	used instead of the M:line name and removed all mentions of
	"N:lines".

	* ircd/s_serv.c: Removed unnecessary close(fd).

2004-11-14  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* include/client.h: Fix for 64bit systems, from QuakeNet.

	* ircd/channel.c: Fixed a reply issue with ACCCHAN (+M).

2004-11-01  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* README.Cygwin: Updated instructions.

	* ircd/m_oper.c: Added some missing send_reply's for remote
	opering.

2004-10-23  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* Code by Entrope.

	* include/client.h: Move sentalong from send.c to struct
	Connection.

	* ircd/m_invite.c: Modified the way invites are sent with
	announcments enabled.

	* ircd/send.c: Delete sentalong array and replace with references
	to con_sentalong().

2004-10-23  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* Tagged stable for AfterNET (Afternet-0_4_0-Stable).

2004-10-20  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* doc/example.conf: Added new feature DNSBL_LOC_EXEMPT.

	* doc/readme.features: Documented DNSBL_LOC_EXEMPT.

	* include/ircd_features.h: Added FEAT_DNSBL_LOC_EXEMPT.

	* ircd/ircd_features.c: Added DNSBL_LOC_EXEMPT (Default FALSE).

	* ircd/m_join.c: Commented out the auto voice code for flexable
	keys for now. Its broken somewhat and im still working on a fix.
	Flexable keys work fine without it, people getting into a chan
	using a it just wont get a auto voice if its +m.

	* ircd/s_user.c: If DNSBL_LOC_EXEMPT is TRUE then if a user who
			  gets a positive match on a DNSBL check logs in
			  using LOC they will get past the DNSBL
			  rejection.
			 Adjusted the format message to use realhost
			  instead of host.
			 Modified exit_client_msg, other servers wont
			  return protocol errors now.
			 Use user->username as cli_username isnt set yet.

2004-10-18  Reed Loden  <reed@reedloden.com>

	* include/ircd_reply.h: Removed MAXLEN as it is no longer used.

	* include/ircd_struct.h: Replaced MAXLEN with BUFSIZE.

	* ircd/ircd_reply.c: Replaced MAXLEN with BUFSIZE.

	* ircd/m_account.c: Couple of changes for optimization.

	* ircd/m_invite.c: Miscellaneous whitespacing changes.

	* ircd/m_trace.c: Changed some code to work with u2.10.11 due 
	to changes in u2.10.12.

	* ircd/s_auth.c: Removed unneeded initialization.

	* ircd/s_conf.c: Replaced RPL_REDIR with RPL_BOUNCE.

	* ircd/s_user.c: Miscellaneous whitespacing changes, replaced
	sptr with acptr (causes a core otherwise), and attempted to fix 
	problem with exit_client_msg() with DNSBL.

	* ircd/support.c: Updated header.

	* include/numeric.h, ircd/gline.c, ircd/m_burst.c,
	ircd/m_trace.c, ircd/s_err.c: Couple of backports of .12 code
	(and fixes).

2004-10-20  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* README: Added BOPM to list.

	* doc/example.conf: Updated X:Line entry with new format.

	* include/client.h: Drop url and name.

	* include/ircd_reply.h: Message formatting declerations.

	* include/ircd_struct.h: Drop url and name.

	* include/s_conf.h: Drop url and name and just use reply.

	* ircd/channel.c: Warning cleanup.

	* ircd/ircd_reply.c: Added a new function from BOPM for
	formatting a message (replacing %i with an IP for example).

	* ircd/m_account.c: Auto host hide with LOC fixed.

	* ircd/m_pass.c: Warning cleanup.

	* ircd/s_auth.c: Only send "Checking your IP against DNS ban lists"
			  done this as a way to get around the multiple
			  notice issue with more than one DNSBL.
			 Adjusted the length of the DNSBL auth notice,
			  was getting blank lines in xchat.

	* ircd/s_conf.c: Warning cleanup.
			 Drop url and name and just use reply.

	* ircd/s_err.c: Shaved off a uneeded %s.

	* ircd/s_stats.c: Removed name section off RPL_STATSXLINE.

	* ircd/s_user.c: Format the DNSBL rejection message using
	format_dnsbl_msg and reject the client.

2004-10-18  Alex Schumann  <rubinlinux@gmail.com>

	* ircd/m_account.c: modded LOC code to resolve some bugs with it.

	* patches/loc.srvx2.diff: The changes necessary to our srvx2 to
	support this. Probably very similar for srvx.

2004-10-18  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* patches/README: Updated with loc patch info etc.

	* ircd/channel.c: Typo fix, -A works now (tested).

	* ircd/m_mkpasswd.c: Replaced &me with sptr in the password reply.

	* ircd/m_account.c: Only use hide_hostmask if we are using style 1.
			    Fixed a bug with AC's being transit'ed.
			    Only set a hidden host if they dont already have
			      one set and only set it if we are using style 1.

2004-10-17  Reed Loden  <reed@reedloden.com>

	* Finally committed my work...
	Look down a bit in ChangeLog to see changes.

	* ircd/channel.c: Removed redundant code.

	* ircd/m_mkpasswd.c: Replaced &me with sptr in error reply.

	* ircd/m_oper.c: Miscellaneous whitespacing change.

	* ircd/s_conf.c: Changed 'O' to "O" to fix warning.

2004-10-18  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* Note login on connect code by Alex Badea
	<decampos@users.sourceforge.net>

	* doc/readme.login-on-connect: Readme file describing how things
	work with login on connect.

	* include/client.h: added con_loc to struct Connection for
	login-on-connect (aka LOC).
	
	* include/ircd_defs.h: added ACCPASSWDLEN define for
	maximum account password length.

	* include/ircd_features.h: Added login on connect F:Line and removed
	verified account ones.
	
	* include/s_misc.h: added LOC counter to ServerStats.

	* include/ircd_struct.h: added struct LOCInfo.
	
	* ircd/ircd_features.c: new feature FEAT_LOGIN_ON_CONNECT

	* ircd/list.c (dealloc_connection): make sure con_loc is free'd.
	
	* ircd/m_account.c: Added AC message sub-types to allow
	authentication requests/replies to travel across the net;
	handle LOC replies. Verified account code removed.

	* ircd/s_user.c (register_user): handle LOC requests; allow
	multiple calls (for LOC retries), using FLAG_CHKACCESS

	* ircd/s_user.c (hide_hostmask): only send RPL_HOSTHIDDEN
	to registered clients, since we might be called by LOC
	before registration.
	
	* ircd/m_pass.c: store auth information for LOC.
	
	* ircd/s_bsd.c (add_connection): set FLAG_CHKACCESS on new local
	clients.
	
	* ircd/s_misc.c (tstats): report login-on-connect counter
	from ServerStats.

2004-10-18  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/channel.c: Applied a small fix posted on sourceforge for
	CIDR bans and freebsd (also applied to exempts).

2004-10-17  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

        * ircd/ircd_relay.c: Dont block bold and underline for +c, as +c
	is only for blocking colours.

2004-10-16  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

        * doc/readme.features: Major update, file should be up to date with
	current features now. Im sure theres spelling or grammar mistakes in
	there probably. Ill give it a decent read on Monday on my day off. Im
	sure reed will get all pedantic before then tho :P

2004-10-15  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* doc/example.conf: Added features AUTOCHANMODES and
	AUTOCHANMODES_LIST, (Quakenet)

	* include/ircd_features.h: Same as example.conf entry above. (Quakenet)

	* include/s_conf.h: Declare find_conf_cidr. (Quakenet)

	* ircd/channel.c: Don't hide QUIT messages from channel 
	services. (Quakenet)
	Added SetAutoChanModes function plus call it if the necessary
	lines are enabled on a first time JOIN. (Quakenet)
	Added support for CIDR channel bans and exempts. (Quakenet)

	* ircd/m_create.c: Dont allow a client to rejoin if its already
	in the channel.

	* ircd/m_account.c: Added needed %s, plus fixed a bug with b0rked
	ACCOUNT messages being sent out.

	* ircd/m_oper.c: Call find_conf_cidr if the other methods to
	check the conf fail etc. (Quakenet).

	* ircd/s_conf.c: find_conf_cidr Function etc. (Quakenet).

2004-10-03  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ChangeLog.nefarious: Updated my email address.

	* README: Updated my email address.

	* ircd/ircd_relay.c: Quakenet updates.

	* ircd/hosthiding.c: Updated my email address.

        * ircd/s_conf.c: Dont parse "include" lines fully, gets an ugly
	I:Line without this continue. Probably would cause issues for
	connecting clients.

	* ircd/version.c.SH: Updated my email address.

	* patches/README: Updated my email address.

2004-09-29  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* configure: Reran autoconf again.

	* configure.in: Ran autoscan against the src, picked up a bunch
	of stuff thats not being checked for, also added package name,
	version and bug report address.

	* config.h.in: Regenerated (header added back in after).

2004-09-29  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* configure: Reran autoconf.

	* config.h.in: Added header and define back in. We will have to add
	this everytime we run autoheader (unless i actually read the man
	page properly as there may be a way of preserving it).

2004-09-29  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* acinclude.m4: Cleaned up some AC_DEFINE's, dont need acconfig.h now.

	* aclocal.m4: Regenerated (aclocal).

	* config.h.in: Regenerated (autoheader).

2004-09-27  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* include/supported.h: Fixed a client parsing issue.

2004-09-20  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/channel.c: Only use flexable keys if its enabled and the
	key is set and valid on a join.

	* ircd/m_join.c: Send out CMD_MODE to other servers.

2004-09-25  Reed Loden  <reed@reedloden.com>

	* doc/example.conf, include/ircd_features.h, ircd/channel.c,
	ircd/client.c, ircd/ircd_features.c, ircd/m_oper.c,
	ircd/s_user.c: Renamed FEAT_OPERLEVELS to FEAT_OPERFLAGS.

	* include/client.h, ircd/channel.c, ircd/m_burst.c,
	ircd/m_oper.c, ircd/m_whois.c, ircd/s_user.c:
	Renamed IsAnAdmin() to IsAdmin().

	* ircd/m_whois.c: Optimizations.

	* ircd/s_conf.c: Changed "O" to 'O'.

2004-09-16  Reed Loden  <reed@reedloden.com>

	* ChangeLog.nefarious: Added some info I had forgotten
	(and removed stuff that is now in Undernet's repository).

	* include/client.h: Added comment to CHFL_HALFOP.

	* ircd/iauth.c: Updated file location.

	* ircd/ircd_alloc.c, ircd/os_bsd.c, ircd/os_generic.c,
	ircd/os_linux.c, ircd/os_openbsd.c, ircd/os_solaris.c:
	Removed excess lines after EOF.

	* ircd/m_topic.c: Optimized some code.

	* ircd/s_auth.c: Optimized some code and moved around stuff.

	* ircd/s_conf.c: Miscellaneous whitespacing changes and 
	optimization of some code.

	* ircd/s_user.c: Miscellaneous text/whitespace changes and
	support for automatic changing of hidden hosts if
	FEAT_OPERHOST_HIDING is TRUE.

	* Synched with u2.10.11.07(pre4) as per 2004-09-15.

2004-09-16  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* Include feature from WhatNET's IRCd (WhatIRCd)
	(http://coder-com.whatnet.org).

	* doc/example.conf: Added includes section.

	* ircd/s_user.c: Modified read configuration file functions
	to handle includes.

2004-09-13  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* Undernet sync.

2004-09-13  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* include/channel.h: Added MODE_ADMINONLY.

	* include/numeric.h: Added ERR_ADMINONLYCHAN.

	* include/supported.h: Added A to channel mode string.

	* ircd/channel.c: Added MODE_ADMINONLY, only allow admins to
	set it and admins can only join +A channels.

	* ircd/m_burst.c: MODE_ADMINONLY added for net rider checks.

	* ircd/m_join.c: Small addition for MODE_ADMINONLY.

	* ircd/s_err.c: See supported.h entry.

2004-09-13  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/m_whois.c: Small bug fix, display +s channels for opers
	now in WHOIS's (prefixed with *).

	* doc/example.conf: Renamed OPLEVELS to OPERLEVELS.

	* include/ircd_features.h: See above.

	* ircd/client.c: See above + let global opers set wide glines
	if enabled.

	* ircd/m_oper.c: See above.

	* ircd/s_user.c: See above.

	* doc/example.conf: New F:lines added OPLEVELS, WHOIS_OPER,
	WHOIS_ADMIN, and WHOIS_SERVICE.

	* include/client.h: Fluff for oper levels added.

	* include/ircd_features.h: see example.conf entry.

	* include/s_conf.h: Some more fluff.

	* include/supported.h: Added A to usermode string.

	* ircd/client.c: Modified privs, give admins certain privs
	if OPLEVELS is enabled, if it isnt then give the privs to
	global opers.

	* ircd/ircd_features.c: See example.conf entry.

	* ircd/m_oper.c: Make the client an admin if they are
	supposed to be an admin. Only works for local opering, not
	remote opering.

	* ircd/m_whois.c: Use the WHOIS_ output.

	* ircd/s_conf.c: Fluff for reading the flags from the conf.

	* ircd/s_err.c: Small tweak to STATSOLINE for displaying
	oper flags.

	* ircd/s_stats.c: Display the flags if needed or otherwise
	the port (used for other lines).

	* ircd/s_user.c: Clear the admin flag if OPLEVELS is disabled.
	This is also done in m_oper.c.

	* configure: Reran autoconf.

	* configure.in: Add -Wno-long-long to CFLAGS on BSD systems.

	* ircd/ircd_relay.c: Minor fix, thought i had put it in the
	place originally. Fixed now.

	* ircd/m_join.c: Small bug fix.

2004-09-12  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/Makefile.in: Remove version.c on a make install, makes
	life easier for keeping track of CVS version when coding.
	
	* More bug fixes, see ChangeLog.

	* ircd/gline.c: Bug fix (see ChangeLog).

	* doc/example.conf: Added ANNOUNCE_INVITES.

	* include/ircd_features.h: Same as example.conf entry.

	* include/numeric.h: Added RPL_ISSUEDINVITE (345).

	* include/send.h: Modified sendcmdto_channel_butserv_butone,
	added sendcmdto_channel_servers_butone.

	* ircd/channel.c: Bug fix (see ChangeLog),
	sendcmdto_channel_butserv_butone updates.

	* ircd/gline.c: sendcmdto_channel_butserv_butone updates.

	* ircd/ircd_features.c: Same as example.conf entry.

	* ircd/m_burst.c: sendcmdto_channel_butserv_butone updates.

	* ircd/m_invite.c: Added announce invites feature.

	* ircd/m_kick.c: sendcmdto_channel_butserv_butone updates.

	* ircd/m_topic.c: sendcmdto_channel_butserv_butone updates.

	* ircd/s_err.c: see numeric.h entry.

	* ircd/s_user.c: sendcmdto_channel_butserv_butone updates.

	* ircd/send.c: sendcmdto_channel_butserv_butone updates.

	* include/supported.h: Added STATUSMSG (isupport), and
	CHANNELLEN.

2004-09-11  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/s_auth.c: Small bug fix, was sending the wrong header.

	* ircd/parse.c: Fixed bug with commands like /1 or /2 being
	accepted, which had wierd sideaffects. Fix by Entrope.

	* doc/example.conf: Added X:Lines stuff.
			    Added features, DNSBL_CHECKS.
					    DNSBL_EXEMPT_CLASS.
					    HIS_STATS_X.

	* include/client.h: Misc DNSBL client declerations.

	* include/ircd_features.h: Added new features (see example.conf).

	* include/ircd_struct.h: Couple of new entries in the User
	struct for dnsbl url and name if a user is matched on a DNSBL.

	* include/numeric.h: Added numeric for stats X (240).

	* include/s_auth.h: DNSBL pending set/is/clear stuff.

	* include/s_bsd.h: release_dnsbl_reply decleration.

	* include/s_conf.h: blline struct and declerations.

	* ircd/ircd_features.c: Added new features (see example.conf).

	* ircd/list.c: DNSBL tweaks.

	* ircd/s_auth.c: Main functions for checking hosts if they
	are active on a DNSBL.

	* ircd/s_conf.c: Functions for building and clearing the
	blline struct. Also a function for searching the blline
	struct.

	* ircd/s_err.c: Added numeric for stats X (240).

	* ircd/s_stats.c: Added /stats X.

	* ircd/s_user.c: Check if a user is marked as ab active dnsbl,
	if so then reject them.

2004-09-08  Reed Loden  <reed@reedloden.com>

	* configure: Ran autoconf.

	* doc/example.conf: Added FEAT_RESTARTPASS and FEAT_DIEPASS.

	* include/client.h: Fixed +z (problem was that SSL is local to
	each server, not global).

	* include/ircd_features.h: Added FEAT_RESTARTPASS,
	FEAT_DIEPASS, and FEAT_XTRAOP_CLASS.

	* include/msg.h: Changed from spaces to tabs like everything 
	else.

	* include/opercmds.h: Added oper_password_match() prototype.

	* include/querycmds.h: Added tunefile prototypes.

	* include/s_conf.h: Changed find_csline() from a char* to an
	int.

	* include/s_misc.h: Removed tunefile prototypes.

	* include/s_serv.h: Removed rules_send() and opermotd_send()
	prototypes.

	* include/supported.h: Added #define clearchanmodes for
	CLEARMODE's default modes.

	* ircd/Makefile.in: Ran "make depend".

	* ircd/channel.c: Corrected spelling errors, and did some
	miscellaneous whitespacing changes.

	* ircd/fda.c, ircd/fda_t.c, ircd/filoio.c, ircd/gline.c, 
	ircd/m_proto.c, ircd/table_gen.c, ircd/uping.c, ircd/whowas.c:
	Removed excess lines after EOF.

	* ircd/hosthiding.c: Miscellaneous changed in whitespace.

	* ircd/ircd.c: Added header for querycmds.h and removed excess 
	line(s) after EOF.

	* ircd/ircd_features.c: Added FEAT_XTRAOP_CLASS (default: 0),
	FEAT_RESTARTPASS (default: NULL), and FEAT_DIEPASS (default:
	NULL).

	* ircd/ircd_relay.c: Allowed non-+R people to talk to
	themselves and removed excess line(s) after EOF.

	* ircd/m_clearmode.c: Added header for supported.h,
	miscellaneous changes, spelling corrections, changed char 
	*control to use #define clearchanmodes.

	* ircd/m_defaults.c, ircd/m_get.c, ircd/m_gline.c, 
	ircd/m_reset.c, ircd/m_settime.c, ircd/map.c: Removed unneeded
	headers.

	* ircd/m_die.c: Added FEAT_DIEPASS and removed unneeded headers.

	* ircd/m_invite.c, ircd/m_set.c: Removed unneeded headers and
	excess line at EOF.

	* ircd/m_oper.c: Changed from opermotd_send() to m_opermotd().

	* ircd/m_opermotd.c: Added opermotd_send() (moved from 
	s_serv.c).

	* ircd/m_opmode.c: Used cli_name(sptr) instead of
	sptr->cli_name.

	* ircd/m_restart.c: Added FEAT_RESTARTPASS and removed
	unneeded headers.

	* ircd/m_rules.c: Added rules_send() (moved from s_serv.c).

	* ircd/m_svsnick.c: Removed unneeded function (still in 
	m_nick()).

	* ircd/m_wallhops.c: Used a better way of displaying '%'.

	* ircd/m_whois.c: Removed redundant MyConnect() check.

	* ircd/querycmds.c: Added tunefile stuff (moved from s_serv.c).

	* ircd/s_conf.c: Changed find_csline() from a char* to an
	int and changed what it returns (0 -> 1).

	* ircd/s_serv.c: Miscellaneous changes, removed rules_send(),
	opermotd_send(), and tunefile stuff (moved to their respective
	files), and changed from [s]rand() to [s]random().

	* ircd/s_user.c: Fixed find_csline(), changed some whitespacing 
	issues, allowed non-+R people to talk to themselves, added 
	XTRAOP_CLASS (default: 0), and fixed problem with +B letting
	a user set +s.

	* ircd/version.c.SH: Moved some stuff around and added a list of 
	very helpful testers.

2004-09-03  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* doc/example.conf: Added feature TPATH (default "ircd.tune").

	* include/ircd_features.h: Added FEAT_TPATH.

	* include/s_misc.h: Function declerations.

	* ircd/ircd.c: Load tune file upon ircd launch.

	* ircd/ircd_features.c: Added TPATH.

	* ircd/s_serv.c: savetune and loadtune functions.

	* ircd/s_user.c: Update the tune file when user counts go up
	above the highest known count.

2004-09-02  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/m_wallhops.c: Couple of fixes with displaying "%".
	% was being duplicated on each server the msg went to.

2004-09-02  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/m_burst.c: Warning cleanup.

	* ircd/m_check.c: Warning cleanup.

	* ircd/m_join.c: Warning cleanup.

	* ircd/m_server.c: Warning cleanup.

	* ircd/m_svsnick.c: Uncommented some code + made it work.

	* ircd/ssl.c: Warning cleanup.

2004-09-02  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* doc/example.conf: typo fix.

	* ircd/ircd_features.c: typo fix.

2004-09-02  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* doc/example.conf: Added FEAT_MAX_CHECK_OUTPUT.

	* include/ircd_features.h: Added FEAT_MAX_CHECK_OUTPUT.

	* ircd/ircd_features.c: Added FEAT_MAX_CHECK_OUTPUT, default 1000.

	* ircd/m_check.c: Actually use FEAT_MAX_CHECK_OUTPUT.

2004-09-02  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* Sync with u2.10.11.07(pre1) as per 2004-08-31 (2 Commits).

	* include/client.h: Is/SetVerifiedAccount stuff.

	* include/ircd_features.h: F:Lines for verified accounts, default
	FALSE.

	* include/numeric.h: Two numerics added, one for error replies
	and the other for WHOIS replies.

	* ircd/ircd_features.c: F:Lines for verified accounts, default
	FALSE.

	* ircd/m_account.c: Re added verified accounts.
	
2004-08-31  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* include/s_user.h: do_nick_name can be called outside of
	m_nick.c now.

	* ircd/m_join.c: Fixed up a feature check.

	* ircd/m_nick.c: Same as s_user.h.

	* ircd/m_svsnick.c: Commented out some code thats not even being
	used. Not deleted for now as reed may still be using it. Added
	an #include for IRCD_MIN.

2004-08-30  Reed Loden  <reed@reedloden.com>

	* include/supported.h: Alphabetized the channel/user mode lists.

	* ircd/m_burst.c: Swaped to .12's version of the anti-netrider
	with exceptions code. Added support for +O and +z in the
	anti-netride and exceptions code.

	* ircd/m_svsnick.c: Added some basic sanity checks.

2004-08-27  Reed Loden  <reed@reedloden.com>

	* doc/example.conf: Added FEAT_CREATE_CHAN_OPER_ONLY (restricts 
	the creation of new channels to oper only) (default: FALSE).

	* include/ircd_features.h: Added FEAT_CREATE_CHAN_OPER_ONLY.

	* ircd/ircd_features.c: Added FEAT_CREATE_CHAN_OPER_ONLY
	(default: FALSE).

	* ircd/m_ircops.c: Reduced the number of IsAnOper() checks by 
	checking it one time and setting a variable (int oper).

	* ircd/m_join.c: Implemented FEAT_CREATE_CHAN_OPER_ONLY, 
	corrected some indenting, and changed MODE_REGONLY to 
	MODE_ACCONLY in the FEAT_FLEXABLEKEYS check.

	* ircd/s_user.c: /SETHOST now ignores hosts that change nothing.

2004-08-28  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* doc/example.conf: Added new feature FLEXABLEKEYS. When TRUE, a
	user joining a channel with the correct key can get past +rliOMm.

	* include/ircd_features.h: Added new feature FLEXABLEKEYS.

	* ircd/channel.c: Made FLEXABLEKEYS work.

	* ircd/ircd_features.c: Added new feature FLEXABLEKEYS.

	* ircd/m_join.c: Made FLEXABLEKEYS work. If the channel is +m
	or +M, then autovoice the user.

2004-08-27  Reed Loden  <reed@reedloden.com>

	* Sync with u2.10.11.07(pre1) as per 2004-08-27.

2004-08-25  Reed Loden  <reed@reedloden.com>

	* doc/example.conf: Renamed FEAT_EXTENDED_CHECKCMD to
	FEAT_CHECK_EXTENDED and added FEAT_NOTHROTTLE.

	* include/ircd_features.h: Renamed FEAT_EXTENDED_CHECKCMD to
	FEAT_CHECK_EXTENDED, moved FEAT_DEFAULT_UMODE, and added
	FEAT_NOTHROTTLE.

	* ircd/IPcheck.c: Added FEAT_NOTHROTTLE to replace
	the NOTHROTTLE #ifdef (default: FALSE).

	* ircd/ircd_features.c: Renamed FEAT_EXTENDED_CHECKCMD to
	FEAT_CHECK_EXTENDED, moved FEAT_DEFAULT_UMODE, and added
	FEAT_NOTHROTTLE.

	* ircd/m_check.c: Corrected a couple of code inconsistances.

	* ircd/m_ircops.c: Miscellaneous whitespace changes and let 
	opers see other opers' idle time.

	* ircd/m_oper.c: Flip-flop'd an 'if' check.

2004-08-25  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* doc/example.conf: Added new feature CHECK_EXTENDED.

	* include/check.h: Added new parm to checkusers.

	* include/ircd_features.h: Added FEAT_CHECK_EXTENDED.

	* ircd/ircd_features.c: Added FEAT_CHECK_EXTENDED
	(default: TRUE).

	* ircd/m_check.c: A few CHECK updates:
	Extended information with FEAT_CHECK_EXTENDED
	An update for flags with CHECK.
	Small F:Line tweak for EXCEPTS.
	Small bug fix with displaying modes in CHECK output.

2004-08-25  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/ssl.c: Generate an error message when a client connects
	to a SSL port on a normal connection (non-SSL).

2004-08-24  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/s_bsd.c: SSL bug fix, was causing cores.

2004-08-23  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/s_serv.c: Burst AWAY messages on links.

2004-08-23  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* Last 2 commits removed (one with no changelog).

2004-08-23  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* include/map.h: Added an extra var to map_update for removing
	a server.

	* ircd/m_server.c: Updated map_update() call.

	* ircd/map.c: if map_update is called with a 1 then the server
	will thats being updated will be removed. This really drops the
	need for the cache time stuff. I'll see how this goes.

	* ircd/s_misc.c: Save as m_server.c entry.

	* ircd/s_serv.c: Save as m_server.c entry.

2004-08-23  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* doc/example.conf: Added F:Lines for HIS_MAP_SCRAMBLED,
	HIS_LINKS_SCRAMBLED and HIS_SCRAMBLED_CACHE_TIME.

	* include/ircd_features.h: Same as above.

	* include/map.h: Declerations etc.

	* ircd/Makefile.in: Compile map.c.

	* ircd/ircd_features.c: Same as the example.conf entry.

	* ircd/m_links.c: Use the scrambled links code if its enabled
	and the user is not an oper.

	* ircd/m_map.c: Same as above.

	* ircd/m_server.c: Updated the map on new links.

	* ircd/map.c: File containing functions for scrambled
	maps/links.

	* ircd/s_misc.c: Update the map on splits.

	* ircd/s_serv.c: Update the map on links.

2004-08-21  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/m_ircops.c: Tweak to IRCOPS HIS stuff.

	* ircd/m_oper.c: Small tweak to yesterdays bug fix.

2004-08-20  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/m_oper.c: Bug fix, allow an oper to "remote oper" on the
	server he/she is on.
	(user on irc.abc.com, /oper irc.abc.com user pass)

2004-08-20  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* doc/example.conf: Added lines for HIS_IRCOPS and
	HIS_IRCOPS_SERVERS.

	* include/ircd_features.h: Same as above.

	* ircd/ircd_features.c: Same as above.

	* ircd/m_ircops.c: If HIS_IRCOPS is TRUE then don't let normal
	users use IRCOPS. If HIS_IRCOPS_SERVERS is TRUE then if a
	normal user can use IRCOPS the opers server will not display.
	HIS_SERVERNAME will be displayed instead.

2004-08-19  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/s_user.c: Bug fix for with default umodes, the mode(s)
	were being sent out to other servers before the nick was even
	sent out.

2004-08-17  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/os_linux.c: Bug fix for fedora systems. This should fix
	the `_SC_CLK_TCK' undeclared  error.

2004-08-15  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/s_user.c: Bug fix for setting +B, the server was letting
	any user set +B. Reported by CaptKirk.

2004-08-13  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/s_user.c: Bug fix for DEFAULT_UMODE, dont know why I
	added the clearhiddenhost part in the first place. When +x was
	auto set and a user logged in, their hidden host wasn't being
	set. This fixes that.

2004-08-13  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* patches/halfops.srvx2.diff: Removed a couple of unneeded
	debugging bits I added while creating the patch. Small code fix
	also.

2004-08-12  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* patches/banexempts.srvx2.diff: Changed strcat to strncat.

2004-08-11  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/channel.c: This should fix the issue with parting a +M
	channel while your not logged in. Previously it would return a
	cannot send to channel error with some data beside it.

2004-08-11  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* patches: Added new directory for services patches

	* patches/README: General patches readme plus listings of all
	patches and what they do.

	* patches/banexempts.srvx2.diff: Afternet SRVX2 banexempts patch.

	* patches/halfops.srvx2.diff: Afternet SRVX2 halfops patch.

2004-07-12  Reed Loden  <reed@reedloden.com>

	* include/patchlevel.h: Bumped for release (0.3.0).

	* ircd/version.c.SH: Add '-' to separate lines.

2004-07-11  Reed Loden  <reed@reedloden.com>

	* ChangeLog: Added entry from Vampire- that we forgot.

	* ChangeLog.nefarious: Added some fluff.

	* Doxyfile: Removed "Daemon" from Nefarious IRCu name.

	* README: Updated list of IRCds we borrowed code from.

	* include/channel.h: Removed unneeded prototypes.

	* include/ircd_features.h: Changed ASUKA_* to OPER_* with the
	exception of CHECK which was changed to just "CHECK".
	Removed SPAMBOT_CHECKS and added STATS_C_IPS.

	* include/ircd_struct.h, include/version.h: Miscellaneous 
	whitespace/placement changes.

	* ircd/Makefile.in: Ran "make depend".

	* ircd/ircd_features.c: Changed ASUKA_* to OPER_* with the
	exception of CHECK, which was changed to just "CHECK".
	Removed SPAMBOT_CHECKS and added STATS_C_IPS.

	* ircd/m_check.c, ircd/m_ircops.c, ircd/m_nick.c,
	ircd/s_user.c: Changed ASUKA_* to OPER_* with the exception of
	CHECK, which was changed to just "CHECK".

	* ircd/m_check.c, ircd/m_topic.c: Optimized several halfop 
	related checks.

	* ircd/s_debug.c: Added characters for NICKGLINES and SSL.

	* ircd/s_stats.c: Added FEAT_STATS_C_IPS (default: FALSE) to let
	opers see the IPs in C:lines.

	* ircd/version.c.SH: Used a cleaner way to get cvs_version.

2004-07-12  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* include/numeric.h: Removed CVS_VERSION.

	* include/version.c: Added char cvs_version.

	* ircd/m_version.c: Removed CVS_VERSION reply.
	Send out the CVS version with RPL_VERSION.

	* ircd/version.c.SH: Used some cat grep n awk action to get the
	CVS version out of ChangeLog.nefarious and throw it into a char
	like creation, version, etc.

2004-07-08  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* doc/example.conf: Added feature BADUSER_URL, gives the user a url
	to go to when they get an invalid username error upon connect.

	* include/ircd_features.h: Added fluff for BADUSER_URL.

	* include/numeric.h: Added new numeric for CVS version reply
	RPL_CVS_VERSION.

	* ircd/ircd_features.c: Added fluff for BADUSER_URL.

	* ircd/m_version.c: Send out the cvs version of CVS_VERSION to a
	user.

	* ircd/s_err.c: fluff for RPL_CVS_VERSION.

	* ircd/s_user.c: Do something with BADUSER_URL, send it out with
	an invalid username error.

2004-07-08  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/ircd_features.c: Fixed up bug in HIS_NETSPLIT.

        * ircd/m_version.c: Added nessecary include for CVS_VERSION.

2004-07-08  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* doc/example.conf: Bumped up the max excepts to 45.
	Adjust various HIS lines to TRUE.

	* ircd/ircd_features.c: Bumped up the max excepts to 45.
	Adjust various HIS lines to TRUE.

2004-07-08  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* include/ircd_features.h: Added feature to disable target limiting.

	* include/patchlevel.h: Bumped patchlevel.

	* ircd/ircd_features.c: Added feature to disable target limiting.

	* ircd/s_user.c: Added feature to disable target limiting.

2004-07-08  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/m_topic.c: Possibly fixed that crash with HOST_IN_TOPIC.

2004-07-08  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/m_wallchops.c: Fixed an issue where notices that you sent would be
	echoed back to you.

	* ircd/m_wallhops.c: Same as above.

	* ircd/m_wallvoices.c: Same as above.

2004-07-08  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* doc/example.conf: Default HOST_IN_TOPIC to false, had a seg fault on a network
	where it had been working fine for a week.

	* ircd/ircd_features.c: Same as above, will be working on a fix.

2004-07-08  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/m_account.c: Quick fix.

2004-07-08  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/channel.c: Odd fix for +z, adding brackets to the check if the user is
		   	   connected via SSL or is a server.
			  Also done this to the +h and +O checks for now. Just in case.
			  Allow halfops to be set if its comming from a server (burst),
			   even if halfops is disabled, will prevent desynchs. This will
			   be removed when i have rewritten my VCTRL code. Once its
			   rewritten we will be able to check whats enabled on link and
			   deny the link if things are not set right.

2004-07-08  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* doc/example.conf: Removed verified accounts code, will be re added later.

	* doc/readme.login-on-connect: Readme detailing login on connects. While the
	code isnt 100% added yet (wont be till 0.4 or so), admins can see what the
	functions will do.

	* include/client.h: Removed verified accounts code, will be re added later.

	* include/ircd_features.h: Removed verified accounts code, will be re added later.

	* include/numeric.h: Removed verified accounts code, will be re added later.

	* ircd/ircd_features.c: Removed verified accounts code, will be re added later.

	* ircd/m_account.c: Removed verified accounts code, will be re added later.
	 		    Added first part of login on connect code.

	* ircd/m_whois.c: Removed verified accounts code, will be re added later.

	 * ircd/s_err.c: Removed verified accounts code, will be re added later.

	* ircd/s_user.c: Removed verified accounts code, will be re added later.

2004-07-07  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/m_whois.c: Reverted verified accounts code back.

	* ircd/s_err.c: Reverted verified accounts code back.

2004-07-07  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* include/ircd.h: Include ircd_struct.h instead of struct.h.

	* include/ircd_struct.h: Old struct.h.

	* include/struct.h: Renamed to ircd_struct.h.

	* include/support.h: Removed MIN define.

	* ircd/ircd_features.c: Include ircd_struct.h instead of struct.h.

	* ircd/ircd_log.c: Include ircd_struct.h instead of struct.h.

	* ircd/ircd_snprintf.c: Include ircd_struct.h instead of struct.h.

	* ircd/jupe.c: Include ircd_struct.h instead of struct.h.

	* ircd/list.c: Include ircd_struct.h instead of struct.h.

	* ircd/m_burst.c: Include ircd_struct.h instead of struct.h.

	* ircd/m_invite.c: Include ircd_struct.h instead of struct.h.

	* ircd/m_links.c: Include ircd_struct.h instead of struct.h.

	* ircd/m_quit.c: Include ircd_struct.h instead of struct.h.

	* ircd/m_sethost.c: Include ircd_struct.h instead of struct.h.

	* ircd/m_settime.c: Include ircd_struct.h instead of struct.h.

	* ircd/m_silence.c: Include ircd_struct.h instead of struct.h.

	* ircd/m_stats.c: Include ircd_struct.h instead of struct.h.

	* ircd/m_userhost.c: Include ircd_struct.h instead of struct.h.

	* ircd/m_userip.c: Include ircd_struct.h instead of struct.h.

	* ircd/Makefile.in: Rename struct.h's to ircd_struct.h.

	* ircd/numnicks.c: Include ircd_struct.h instead of struct.h.

	* ircd/opercmds.c: Include ircd_struct.h instead of struct.h.

	* ircd/parse.c: Include ircd_struct.h instead of struct.h.

	* ircd/res.c: Include ircd_struct.h instead of struct.h.

	* ircd/s_auth.c: Include ircd_struct.h instead of struct.h.

	* ircd/s_bsd.c: Include ircd_struct.h instead of struct.h.

	* ircd/s_conf.c: Include ircd_struct.h instead of struct.h.

	* ircd/s_debug.c: Include ircd_struct.h instead of struct.h.

	* ircd/s_misc.c: Include ircd_struct.h instead of struct.h.

	* ircd/s_numeric.c: Include ircd_struct.h instead of struct.h.

	* ircd/s_serv.c: Include ircd_struct.h instead of struct.h.

	* ircd/s_stats.c: Include ircd_struct.h instead of struct.h.

	* ircd/s_user.c: Include ircd_struct.h instead of struct.h.

	* ircd/send.c: Include ircd_struct.h instead of struct.h.

	* ircd/userload.c: Include ircd_struct.h instead of struct.h.

	* ircd/whocmds.c: Include ircd_struct.h instead of struct.h.

	* ircd/whowas.c: Include ircd_struct.h instead of struct.h.

2004-07-05  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

        * ircd/channel.c: Removed some unnessecary checks

	* ircd/m_burst.c: Removed some unnessecary checks

2004-07-05  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* include/patchlevel.h: Bumped the patchlevel, so we can differ between
	who has +he and who doesnt. Should be a bump after every major commit.

2004-07-05  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* doc/example.conf: Default halfops to false, suggestion by Rubin.

	* ircd/ircd_features.c Default halfops to false, suggestion by Rubin.

2004-07-05  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* README: Added Whatnet's ircd in as we got the halfops code
	from their ircd ty ty.

	* doc/example.conf: Added in all the new F:Lines

	* include/channel.h: Halfop / Except fluff.

	* include/handlers.h: Fluff for WALLHOPS.

	* include/ircd_features.h: Fluff for the new features.

	* include/list.h: struct for excepts.

	* include/msg.h: WALLHOPS fluff (WV).

	* include/numeric.h: New numerics added for excepts and half ops.

	* include/send.h: Fluff for WALLHOPS.

	* include/supported.h: Added in except and half op stuff. Now we still
	send it EVEN if the functions are disabled. The code is important
	because if you enable say half ops after clients have connected
	the clients will not know how to parse the +h stuff and now screw up.

	* ircd/Makefile.in: Added m_wallhops.c

	* ircd/channel.c: So many changes/additions. Added in half ops and
	excepts.

	* ircd/ircd_features.c: Added in fluff for the new F:Lines.

	* ircd/m_burst.c: New code to handle excepts and half ops, to burst
	excepts its done like this:
	S BURST #channel 87654321 +modes clients:ohv :%ban1 ~ except1
	The ~ is a seperator, its not a ban or an except.

	* ircd/m_check.c: Code to understand excepts and half ops.

	* ircd/m_clearmode.c: Same as above.

	* ircd/m_invite.c: Allow half ops to invitre.

	* ircd/m_kick.c: Allow half ops to kick users but not ops.

	* ircd/m_mode.c: Halfop stuff.

	* ircd/m_names.c: Show a % in the NAMES output for half oped
	users.

	* ircd/m_topic.c: Allow half ops to change the topic.

	* ircd/m_wallchops.c: Know what WALLHOPS are.

	* ircd/m_wallhops.c: New command WALLHOPS, just like WALLCHOPS
	and WALLVOICES.

	* ircd/m_wallvoices.c: Know what WALLHOPS are.

	* ircd/m_whois.c Show a % in the WHOIS output for half oped
	users.

	* ircd/parse.c: WALLHOPS fluff.

	* ircd/s_debug.c: Debug code for excepts.

	* ircd/s_err.c: Added in the new numerics.

	* ircd/s_user.c: Halfops stuff.

	* ircd/send.c: WALLHOPS stuff.

	* ircd/whocmds.c: Show a % in the WHO output for half oped
	users.

2004-07-03  Reed Loden  <reed@reedloden.com>

	* include/channel.h, include/client.h, ircd/channel.c,
	ircd/m_join.c, ircd/m_part.c: Rip out Dianora's anti spambot
	code. This works better when used as a service.

	* include/numeric.h: Change nefarious to Nefarious.

	* ircd/m_whois.c: Modify how RPL_WHOISVERIFIED is sent.

	* ircd/s_err.c: Modify what RPL_WHOISVERIFIED says.

	* ircd/version.c.SH: Fix whitespacing and copyright text.

2004-07-03  Reed Loden  <reed@reedloden.com>
	    Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/channel.c: Actually fixed the problem with MODE_OPERONLY 
	and MODE_SSLONLY not bursting correctly.

2004-07-02  Reed Loden  <reed@reedloden.com>

	* ChangeLog.nefarious: Various indent, spacing, etc. changes.

	* config.guess: Updated to timestamp 2004-06-11.

	* config.sub: Updated to timestamp 2004-03-12.

	* include/channel.h: Move MODE_NOLISTMODES to 0x200000.

	* include/ircd_defs.h: Move #define AUTOJOIN_CHANNEL to bottom
	part of file.

	* include/motd.h, include/struct.h: Moved MAX_DATE_STRING from
	struct.h to motd.h.

	* include/msg.h: Correct indent/spacing with CREDITS and 
	COPYRIGHT.

	* include/patchlevel.h: Bump patchlevel (0.2.1).

	* include/supported.h: Correct chmode 'L' placement.

	* ircd/channel.c: Fix bug related to +O and +z chmodes that 
	caused the IRCd to call send_notoper().

	* ircd/listener.c: Make encrypted (SSL) ports display 'E'
	instead of 'C'.

	* ircd/m_burst.c: Burst MODE_NOLISTMODES.

	* ircd/m_clearmode.c: Correct chmode 'L' placement.

	* ircd/m_copyright.c: Correct indent/spacing.

	* ircd/m_ircops.c: Revert to version in which opers cannot see
	services (works better for now until I figure out another way).

	* ircd/motd.c: Correct indent/spacing and add
	#include <stdio.h>.

	* ircd/s_user.c: Correct indent/spacing.

	* ircd/ssl.c: Correct indent/spacing.

	* ircd/version.c.SH: Correct indent/spacing and add current 
	maintainers of IRCu.

2004-06-23  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* include/ircd_features.h: Changed spambot check feature to
	FALSE.

	* include/patchlevel.h: Bumped patchlevel (0.2.0).

	* include/supported.h: Added L to CHANMODES.

	* ircd/ircd_features.c: Changed spambot check feature to FALSE.

2004-06-21  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/m_rehash.c: Added new flag "s" so that an ircd.pem file
	can be reloaded.

2004-06-21  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/m_topic.c: Fixed potential crash; don't want to do the
	user@host for a topic coming from a server (in topic bursts).

2004-06-20  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* tools/makepem: Added basic support for users who already have 
	an existing SSL certificate they wish to use.

2004-06-20  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/s_user.c: Don't let unregistered users send B:Line'd 
	commands.

2004-06-20  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* include/channel.h: Bumped up the size of topic_nick more so
	it can hold a user's ident and a !.

	* ircd/m_topic.c: Must of been tried when I done the host in
	topic stuff. Added the display of a users ident, so now the
	output looks like this:
	[03:03] * Set by gandalf!BigDaddy@306cb8dc.15ce75d4.jet.net.nz
	on Sun Jun 20 02:28:41

2004-06-19  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* doc/example.conf: Added new F:Line.

	* include/ircd_features.h: Added FEAT_TIME_IN_TIMEOUT.

	* ircd/ircd_features.c: Added FEAT_TIME_IN_TIMEOUT (default FALSE).

	* ircd/ircd.c: Display the amount of time since the last ping
	in the time in the Ping Timeout message.

2004-06-19  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* doc/example.conf: Added new F:Line.

	* include/ircd_features.h: Added FEAT_HOST_IN_TOPIC.

	* ircd/ircd_features.c: Added FEAT_HOST_IN_TOPIC (Default TRUE).

	* ircd/m_topic: Made FEAT_HOST_IN_TOPIC useful, if it's enabled
	the host will be added to topic_nick (See Below). RFE 975655.

2004-06-19  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* include/channel.h: Bump up the size of topic_nick so it can
	hold a host.

	* ircd/m_topic.c: When a topic is set, add the host into
	topic_nick so that when a topic is displayed the full user@host
	is in the Set by part. Eg:
	[09:45] * Set by gandalf@36df16fa.25b5c948.jet.net.nz
	on Sat Jun 19 09:34:55

2004-06-19  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* doc/example.conf: Added feature DEFAULT_UMODE.

	* doc/readme.features: Documented new feature.

	* include/ircd_features.h: Replaced feature AUTOHIDE with
	DEFAULT_UMODE.

	* ircd/ircd_features.c: Replaced feature AUTOHIDE with
	DEFAULT_UMODE (default "+").

	* ircd/s_user.c: Took out the AUTOHIDE stuff and put in some
	code to handle DEFAULT_UMODE.

2004-06-19  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* include/channel.h: Added MODE_NOLISTMODES (+L).

	* include/supported.h: Added new mode into the string of 
	channel modes.

	* ircd/channel.c: Added fluff for the new mode.
	If the user doing the /list is not an oper and the channel
	currently being processed has +L set then the modes will
	not be displayed beside the topic.
	Feature idea/request from Bell (AfterNET).

	* ircd/m_clearmode.c: Added fluff for MODE_NOLISTMODES.

2004-06-19  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/res.c: Send out a notice for a resolver restart.

	* ircd/s_user.c: Restart the resolver upon a rehash;
	patch from Fredrik Söderblom (froo).

2004-06-18  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/m_account.c: Fixed small issue.

2004-06-18  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* doc/example.conf: Added features NOTVERIFIED (string msg) and
	VERIFIED_ACCOUNTS (default: FALSE).

	* include/client.h: Added FLAG_VERIFIED, IsVerified and SetVerified.

	* include/ircd_features.h: Added features NOTVERIFIED and
	VERIFIED_ACCOUNTS.

	* include/numeric.h: Added RPL_WHOISVERIFIED (340) and
	ERR_NOTVERIFIED (538).

	* ircd/ircd_features.c: Added features NOTVERIFIED and
	VERIFIED_ACCOUNTS.

	* ircd/m_account.c: Added new paramater to AC, "v" aka verified;
	syntax: "sNumeric AC tNumeric account timestamp v"
	Note: the code will have to change once we start having the
	need for more than one flag, ie "vgra".

	* ircd/m_whois.c: Spit out whether a user is or isn't verified
	in the WHOIS output.

	* ircd/s_err.c: Added RPL_WHOISVERIFIED (340) and 
	ERR_NOTVERIFIED (538). Fixed a few numbers I never noticed
	before.

	* ircd/s_user.c: Only allow +x'ing for users who are verified 
	when VERIFIED_ACCOUNTS is TRUE. Note that VERIFIED_ACCOUNTS 
	only works with hosthiding style 1.

2004-06-17  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* tools/zBounce/*: Major sync of zBounce off the main zBounce
	project CVS.

2004-06-17  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* README: Updated my email address + bumped date.

	* doc/example.conf: Added feature SPAMBOT_CHECKS, defaults to TRUE.

	* include/channel.h: Added spambot check settings, will look
	into making some of these F:Lines at some point.

	* include/client.h: Stuff for spambot checks added into the
	Client structure.

	* include/ircd_features.h: Added feature SPAMBOT_CHECKS.

	* ircd/channel.c: Added main function for the spam bot checks. 
	RFE 972232. Note: patch was written by Diane Bruce <db@db.net>.

	* ircd/ircd_features.c: Added feature SPAMBOT_CHECKS, defaults
	to TRUE.

	* ircd/m_join.c: Bump up the counts for the spambot checks.

	* ircd/m_nick.c: Unrelated change, remove a var not in use.

	* ircd/m_part.c: If SPAMBOT_CHECKS is TRUE and the client isnt
	an oper then check for spambot warnings.

2004-06-16  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* ircd/s_user.c: Only send the cipher notice to SSL users only!

2004-06-16  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* configure: Regenerated configure.

2004-06-16  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* configure.in: Added a macro to for kerberos includes. Should
	fix SSL errors. configure will be regenerated and committed in
	5 mins on another box.

	* include/ssl.h: Cleaned up a bit and added in declerations for 
	some new functions.

	* ircd/IPcheck.c: SSL Clean up.

	* ircd/s_user.c: Notice a connecting user with SSL what cipher 
	they are connected via.

	* ircd/ssl.c: Added functions used for fetching ciphers for a 
	client who is connected via SSL.

2004-06-16  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* include/handlers.h: Add copyright function declerations.

	* include/msg.h Add COPYRIGHT fluff.

	* include/version.h: Added copyrighttext char.

	* ircd/Makefile.in: Added in m_copyright.c

	* ircd/m_copyright.c: File containing nessecary code for
	copyright command.

	* ircd/parse.c: Added in COPYRIGHT command fluff.

	* ircd/version.c.SH: Added GPL/Copyright text.

2004-06-16  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* include/msg.h: Added CREDITS fluff.

	* ircd/parse.c: Added CREDITS command, simply calls the m_info,
	etc. functions.

2004-06-15  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* doc/example.conf: Added in feature MOTD_LAST_CHANGED
	(default FALSE).

	* include/ircd_features.h: Added in feature MOTD_LAST_CHANGED.

	* include/struct.h: Added in MAX_DATE_STRING, will possible 
	change to a different .h file.

	* ircd/ircd_features.c: Added in feature MOTD_LAST_CHANGED.

	* ircd/motd.c: Set the last modified date of ircd.motd into a 
	char for use in s_user.c.

	* ircd/s_user.c: if MOTD_LAST_CHANGED is enabled then send out
	a notice to connecting users before the motd is displayed. The
	notice contains the date of when the motd was last modified
	(RFE 972238).

2004-06-15  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* doc/readme.features: Documented FEAT_GEO_LOCATION.

	* include/ircd_features.h: Added in FEAT_GEO_LOCATION.

	* ircd/ircd_features.c: Added in FEAT_GEO_LOCATION
	(default NULL).

	* ircd/s_err.c: Modified RPL_CREATION, reworded it a bit and
	added in GEO_LOCATION.

	* ircd/s_user.c: Modifed RPL_CREATION so it sends out 
	GEO_LOCATION if its defined in ircd.conf (RFE 972237).

2004-06-11  Rubin  <rubin@afternet.org>

	* ircd/m_nick.c: Removed X* nick blocking code for AfterNET

2004-06-10  Reed Loden  <reed@reedloden.com>

	* include/patchlevel.h: Bump patchlevel (0.1.0).

	* ircd/m_ircops.c: Allow opers to view all opers including 
	services; allow users to see non-+k users (remove 
	FEAT_SERVICES_TLD).

	* ircd/s_user.c: Fix bug with sethost not being sent in burst.

2004-06-08  Reed Loden  <reed@reedloden.com>

	* ircd/m_check.c, ircd/m_userhost.c, ircd/m_userip.c, 
	ircd/m_whois.c, ircd/s_user.c, ircd/whowas.c: Clean-up of
	FEAT_HOST_HIDING_STYLE code and various other code clean-ups.

	* ircd/m_ircops.c: Quick fix for weird behavior due to 
	uninitialized variable; disable use of ms_ircops() for now; 
	fixed it again.

	* ircd/m_topic.c, ircd/s_user.c: Fix warnings.

	* ircd/m_svsnick.c: Update copyright.

	* tools/linesync/linesync.conf: Add 'F' to ALLOWED_LINES.

	* Sync with u2.10.11.07(pre1) as per 2004-06-08.

2004-06-07  Reed Loden  <reed@reedloden.com>

	* ChangeLog.nefarious: Correct a couple of things.

	* configure: Regenerate using autoconf.

	* configure.in: Correct a typo.

	* config.h.in: Correct a typo.

	* include/gline.h: Change value of GLINE_MAX_EXPIRE if
	NICKGLINES are enabled.

	* include/ircd_features.h: Add asuka's HIS_USERGLINE.

	* ircd/gline.c: Clean-up some code and spacing.

	* ircd/ircd_features.c: Change default FEAT_BADCHAN_REASON
	value. Add asuka's HIS_USERGLINE.

	* ircd/m_gline.c: Add asuka's HIS_USERGLINE.

	* ircd/m_nick.c: Clean-up some code and spacing.

	* ircd/m_sethost.c: Revert an unneeded "fix" as I had already 
	fixed it. ;P

	* ircd/m_topic.c: Fix topicburst.

	* ircd/random.c: Remove unneeded #include.

2004-06-06  Neil Spierling  <sirvulcan@sirvulcan.co.nz>

	* configure.in: Added --disable/enable-nickglines;
	used throughout the ircd in ifdef's.

	* configure: Reran autoconf.

	* config.h.in: Added NICKGLINES.

	* doc/example.conf: Added F:Line for BADCHAN_REASON.

	* doc/readme.gline: Nickgline documentation included.

	* include/gline.h: Added nessecary declarations etc for
	Nick Glines.

	* include/ircd_features.h: Added FEAT_BADCHAN_REASON.

	* ircd/gline.c: Added Nick Glines.
	Stats G will now display Badchans, Realname glines aswell as
	normal glines (just like GLINE (with no parameters).
	Added FEAT_BADCHAN_REASON, allows admins to specify the reason
	given in a kick message on users when a channel is badchanneled.
	e.g.: User was kicked by server (This channel has been banned
	(oper reason)... The "This channel has been banned" bit is
	customizable via FEAT_BADCHAN_REASON.

	* include/ircd_features.c: Added FEAT_BADCHAN_REASON.

	* ircd/m_nick.c: Nickgline stuff added - don't let normal users
	use glined nicks.

	* ircd/s_err.c: Nickgline stuff added.

	* ircd/whocmds.c: Nickgline stuff added.

2004-06-04  Reed Loden  <reed@reedloden.com>

	* Corrected all warnings.

	* Added fakehost (from GameSurge) support.

	* Redid lots of code.

	* ircd/Makefile.in: Run "make depend".

	* ircd/m_check.c: Fix bug with cli_ip (from QuakeNet).

	* ircd/m_ircops.c: Add ms_ircops() to allow services to send an
	/IRCOPS to a user.

	* ircd/m_sethost.c: Fix bug with uninitialized variable (from 
	QuakeNet).

	* ircd/m_svsnick.c: Add SVSNICK support as requested by 
	CaptKirk` (Quarantined/Protium). Will add F:lines later.

2004-06-01  Reed Loden  <reed@reedloden.com>

	* Sync with u2.10.11.07(pre1).

	* Add beware's (Bas Steendijk) fix for ban matching.

2004-04-11  Neil Spierling  <sirvulcan@sirvulcan.org>

	* aclocal.m4: Added some extra macros for checking for the
	executable extension (handy for windows) + reran autoconf.

	* configure.in: If the host is a cygwin system then hide
	autoimport stuff; also reran autoconf.

	* ircd/Makefile.in: Use the extension found via the exta
	aclocal macros, chmod ircd properly in windows.

2004-04-05  Neil Spierling  <sirvulcan@sirvulcan.org>

	* ircd/ircd.c: Added a few more optional parameters to the
	ircd, they will make life easier for users using the ircd under
	windows.

2004-02-16  Neil Spierling  <sirvulcan@sirvulcan.org>

	* doc/example.conf: Updated with new F:Lines.

	* include/ircd_features.c: Updated with new F:Line (see below).

	* ircd/hosthiding.c: Functions required for HOST_HIDING_STYLE 2.

        * ircd/ircd_features.c: Added FEAT_QUOTES, FEAT_POLICY_NOTICE,
	FEAT_CMD_RULES, FEAT_HOST_HIDING_STYLE,	and FEAT_CMD_OPERMOTD.
	Took read only status off a new path F:Lines.

	* ircd/m_oper: FEAT_CMD_OPERMOTD support added.

	* ircd/m_opermotd: FEAT_CMD_OPERMOTD support added.

	* ircd/m_rules.c: FEAT_CMD_RULES support added.

	* ircd/m_server.c: Display IP in unauthorised connection
	notices.

	* ircd/m_svsnoop.c: Services only command, can completely
	disable all O:Lines.

	* ircd/s_user.c: FEAT_QUOTES and FEAT_POLICY_NOTICE support
	added.

2004-02-15  Reed Loden  <reed@reedloden.com>

	* More work on merging BoxenIRCu and evilnet IRCu including 
	fixing bugs. If I have time, I'll add a full ChangeLog later.

2004-02-15  Neil Spierling  <sirvulcan@sirvulcan.org>

	* configure.in: Added in some humor.
			Epoll checks fixed.
			OpenSSL checks improved.

	* configure: Regenerated off configure.in.

	* doc/example.conf: Updated with new F:lines.

	* doc/ircd.quotes: Random quote file.

	* doc/ircd.opermotd: OPERMOTD template.

	* doc/ircd.rules: RULES template.

	* doc/ircd.motd: MOTD template.

	* ircd/Makefile.in: Run makepem at the end of make,
	makepem will exit if SSL is disabled.

	* ircd/ircd_features.c: New F:lines for AUTOJOIN and a few more paths.

	* ircd/m_gline.c: Allow for gline lengths to be specified
	as ie 1d2m1s.

	* ircd/m_jupe.c: Allow for jupe lengths to be specified as
	ie 1d2m1s.

	* ircd/m_opermotd.c: MOTD for opers only.

	* ircd/m_rules.c: Network Rules output.

	* ircd/s_err.c: Various replies added for RULES and OPERMOTD.

	* ircd/s_user.c: AUTOJOIN functionality added (off by default).
			 Random quotes added.
			 Policy notice added.

	* ircd/s_serv.c: Various functions added for rules, opermotd and
	random quotes.

	* ircd/support.c: Added dgets function.
			  Added is_timestamp.
			  Added ParseInterval.

2004-02-14  Reed Loden  <reed@reedloden.com>

	* Renamed everything to nefarious as per merger between 
	BoxenIRCu and evilnet IRCu.

	* Synched with u2.10.11.07(pre1).

	* config.guess, config.sub: Updated to latest svn version
	from savannah.gnu.org.

	* include/ircd_features.h, ircd/ircd_features.c: Moved some 
	new features down to the "nefarious features" block.

2003-12-07  Reed Loden  <reed@reedloden.com>

	* include/patchlevel.h: Bump patchlevel.

	* ircd/m_pass.c: Fix core caused by no password.

	* ircd/m_svspart.c: Forgot size of array.

2003-12-06  Reed Loden  <reed@reedloden.com>

	* ircd/ircd_features.c: Send notice to "from", also.

	* ircd/ircd_relay.c: Remove redundancy in
	client_can_send_to_channel() checks.

	* ircd/m_check.c: Send real host to opers.

	* ircd/m_ircops.c: Ignore services.

	* ircd/m_join.c: Fix local channel if statement.

	* ircd/m_nick.c: Remove unneeded asuka text.

	* ircd/m_opmode.c: Remove excess line at EOF.

	* ircd/m_svspart.c: Call m_part() and have it do the job
	instead of actually parting the user.

	* ircd/m_wallchops.c: Don't see WALLCHOPS to sender.

	* ircd/m_whois.c: Don't send NETWORK with RPL_WHOISSERVICE.

	* ircd/s_err.c: Don't send NETWORK with RPL_WHOISSERVICE and
	reformat RPL_WHOISACCOUNTONLY.

	* ircd/s_user.c: Send 004 in the correct order (thanks cnix),
	fix checks on new asuka commands, and other miscellaneous
	stuff.

	* ircd/whocmds.c: Fixed bug where a channel of +n user is
	leaked via WHO (synched from QuakeNet repository).

	* Sync with u2.10.11.06.(pre3).

2003-11-24  Reed Loden  <reed@reedloden.com>

	* include/ircd_features.h: Add FEAT_REMOTE_MOTD.

	* include/motd.h: Increase normal remote motd from 3 to 5 lines.

	* ircd/ircd_features.c: Add FEAT_REMOTE_MOTD (default off).

	* ircd/ircd_xopen.c: Remove excess line at EOF.

	* ircd/m_mkpasswd.c: Randomize the seed a bit more and get rid
	of the include of crypt.h since it is not even needed.

	* ircd/m_oper.c: Did more work and fixed more bugs.

	* ircd/motd.c: Add REMOTE_MOTD.

2003-11-25  Matthias Crauwels <ultimate_@wol.be>
	
	* ircd/m_oper.c: Fixed some bugs in remote oper

2003-11-23  Reed Loden  <reed@reedloden.com>

	* Sync with u2.10.11.06.(pre2).

	* Fix lots of bugs.

	* Add MODE_STRIP (+S) and MODE_NOAMSG (+T).
	(credits to NetGamers/SiRVulcaN)

	* Rename MODE_SSLONLY to +z.

	* Add a lot of ASUKA stuff that is disabled by default for
	various other networks that use nefarious. Most of these
	required that I redo other things so they would work properly.
	- Check
	- XtraOp
	- HideChans
	- HideIdle

	* Add FEAT_OPER_LOCAL_CHANNELS so when local channels are
	disabled, opers can still join.

	* ircd/channel.c: Fix modestuff in /list (thanks IK).

	* ircd/m_clearmode.c, ircd/m_opmode.c: Use
	cli_user(tmp->user)->server instead.

2003-11-04  Reed Loden  <reed@reedloden.com>

	* Sync with u2.10.11.05 release.

	* include/handlers.h, include/msg.h, ircd/Makefile.in,
	ircd/parse.c: Rename SAJOIN/SAPART to SVSJOIN/SVSPART.

	* ircd/Makefile.in: Run "make depend".

	* ircd/m_ircops.c: Fix problem when using /ircops server.* where
	the total number of IRCops was always the number of network
	opers and not just the number on the specific server.

	* ircd/m_svsjoin.c: Instead of using FindClient and FindUser,
	use findNUser; also changed other various stuff.

	* ircd/m_svspart.c: Instead of using FindClient and FindUser,
	use findNUser; also changed other various stuff.

	* ircd/m_wallchops.c: Send a copy of the wallchops back to the
	sender.

	* ircd/m_wallvoices.c: Send a copy of the wallvoices back to
	the sender.

	* ircd/numnicks.c: Remove excess lines at EOF.

	* ircd/s_user.c: Redo some various stuff, add a missing '}',
	and don't let sethost'ed users walk through bans.

2003-11-02  Reed Loden  <reed@reedloden.com>

	* doc/readme.features: Update documentation.

	* ircd/gline.c: Use ircd_snprintf instead of strcpy.

	* ircd/ircd_features.c: Add missing comma (found by Kingpin).

	* ircd/s_user.c: Only show nick change notices if the user is
	on that specific server.

	* ircd/version.c.SH: Add missing comma (found by Amy).

2003-10-31  Reed Loden  <reed@reedloden.com>

	* doc/readme.features: Update documentation.

	* doc/example.conf, doc/ircd.conf.sample: Update documentation.

	* include/ircd_features.h: Add FEAT_SERVICES_TLD and
	FEAT_HIS_STATS_b.

	* include/numeric.h: Add RPL_STATSBLINE (229).

	* ircd/gline.c: Fix issue where some g-lines were not getting
	the "G-lined (<reason>)" prefix.

	* ircd/ircd_features.c: Add FEAT_SERVICES_TLD and
	FEAT_HIS_STATS_b.

	* ircd/m_burst.c: Allow global opers to netride.

	* ircd/m_clearmode.c: Add more modes to the default clearmode.

	* ircd/m_ircops.c: Use FEAT_SERVICES_TLD instead of ".Services"
	so that other networks using nefarious ircd can change it more
	easily.

	* ircd/m_trace.c: Remove excess lines at EOF.

	* ircd/parse.c: Backport Dianora's complete rewrite of parse.c.

	* ircd/s_conf.c: Formatting changes.

	* ircd/s_err.c: Add RPL_STATSBLINE (229).

	* ircd/s_stats.c: Add /stats B support.

	* ircd/s_user.c: Remove unneeded code.

	* ircd/version.c.SH: Add cnix's header line change.

2003-10-27  Reed Loden  <reed@reedloden.com>

	* include/ircd_string.h, ircd/ircd_string.c: Remove
	ircd_strrcmp() macro and use an ircd_strrcmp() function instead.

	* ircd/m_ircops.c: Redo .Services stuff yet again.

	* ircd/s_user.c: Fixed a very annoying core by changing several
	sptr's to acptr's.

2003-10-26  Reed Loden  <reed@reedloden.com>

	* ircd/m_ircops.c: Fix .Services stuff.

2003-10-25  Reed Loden  <reed@reedloden.com>

	* Sync with u2.10.11.05pre5.(part).(whois)

	* ircd/gline.c: Added missing "continue;" so badchanneling
	works properly.

	* ircd/ircd_features.c: Update hidden hosts as per voting
	results.

	* ircd/m_info.c: Added missing comma.

2003-10-23  Reed Loden  <reed@reedloden.com>

	* include/patchlevel.h: Bump patchlevel.

	* ircd/gline.c: Add IK's fixes.

	* tools/linesync/linesync.conf: Update linesync information.

2003-10-19  Reed Loden  <reed@reedloden.com>

	* ircd/gline.c: Incorporate IK's complete rewrite of the gline
	quit reason parser and add consideration for when a service
	does the gline but the reason does not start with a '<'.

2003-10-18  Reed Loden  <reed@reedloden.com>

	* include/ircd_string.h: Add an ircd_strrcmp() macro.

	* ircd/gline.c: Tidy up clsk's fix and remove redundancy by
	using refactoring (plus fix it).
	(thanks IK!)

	* ircd/m_ircops.c: Completely hide any opers on servers ending
	in ".Services".

2003-10-18  Alan Alvarez  <nirvana_alan@hotmail.com>

	* ircd/gline.c: Fix memory going out of bounds by allocating
	memory on the heap.

2003-10-12  Jochen Meesters  <spike@undernet.org>

	* ircd/m_rehash.c: Small fix.

2003-10-07  Reed Loden  <reed@reedloden.com>

	* ircd/gline.c: New way of doing gline quit reasons as
	requested by Rubin. (made by clsk, modified by myself)

2003-10-02  Reed Loden  <reed@reedloden.com>

	* include/handlers.h, ircd/m_rehash.c, ircd/parse.c: Added
	remote rehash support. (made by clsk, modified by myself)
	NOTE: NOT TESTED YET!

	* ircd/m_ircops.c: More formatting changes.

	* ircd/m_quit.c: If MODE_COLOUR is on, don't let people use
	color in quits.

2003-09-30  Reed Loden  <reed@reedloden.com>

	* ircd/match.c, ircd/m_ircops.c, ircd/s_user.c: Fixed bugs.

	* ircd/m_ircops.c: Formatting changes.

	* ircd/ircd_relay.c: Oops... block NOTICES, not PRIVMSGS. :p

2003-09-29  Reed Loden  <reed@reedloden.com>

	* ircd/s_user.c: Send out a connexit notice for the
	nick change before cli_name(sptr) is overwritten with
	the new nick. (requested by royalsexy)

	* Sync with u2.10.11.05.

	* Fix a silly bug in the old version of IRCOPS. New version
	coming soon (as soon as clsk finishes with his bug fixes).

	* Added MODE_NONOTICE (Yet Another QuakeNet Mode[tm]).

	* Completely new IRCOPS version made mostly by clsk and
	modified a bit by myself.

2003-09-27  Reed Loden  <reed@reedloden.com>

	* Got rid of a lot of the HEAD_IN_SAND stuff.

	* Changed IsColorChannel to IsColor and added a check for
	colors in quit/part msgs when MODE_NOCOLOUR is on. -wasted

	* Reverted map and links back to original.

	* IRCOPS now only shows globals and idle time has been added.

2003-09-05  Reed Loden  <reed@reedloden.com>

	* Added a lot and fixed a ton. I'll finish this ChangeLog entry
	later when I have more time.

2003-08-25  Martijn Smit  <wasted@whatnet.org>

	* include/channel.h, ircd/channel.c, ircd/m_invite.c,
	ircd/m_join.c: Don't allow users to use color codes with
	/invite and move color dection to a function for further use.

2003-07-15  Mathieu Rene  <math@rootservices.net>

	* include/s_user.h, ircd/s_user.c: Fixed a warning by removing
	a "const" qualifier.

2003-07-15  Reed Loden  <reed@reedloden.com>

	* Added and modified some more of SiRVulCaN's patches.
	  - +M ACCOUNT Only Channel Mode
	  - Local/Global LUSERS Counts
	  - RPL_REDIR Connection Redirection (R:lines)
	  - SVSJOIN Command (services only)
	  - SVSPART Command (services only)

	* Messed with the REMOTEOPER macros again.

	* Added MODE_OPERONLY and MODE_SSLONLY.

	* Modded SSL stuff to use #ifdef USE_SSL.

	* Added some SSL macros and another reply in whois.

	* Did some work on configure/aclocal/etc. stuff.

	* Added B:lines from ircu-eden.

	* Added FEAT_HIS_MAP_CRIPPLED and FEAT_HIS_LINKS_CRIPPLED
	from ircu-eden.

	* ircd/s_auth.c: Modify AUTH_TIMEOUT from 30 to 8.

	* Sync with u2.10.11.05: Unwrap the connected counter in
	ip_registry_check_local() before returning.

	* As per Math's recommendation, removed umode +S. Now, SSL users
	are only kept track of via FLAG_SSL.

	* Actually do SetSSL() on SSL users.

	* Renamed q:lines to R:lines because they stand for
	"Redirection lines".

	* Stomped out several compiler warnings.

	* Oops, forgot doc/readme.features.

2003-07-05  Reed Loden  <reed@reedloden.com>

	* ircd/s_user.c: Fixed a problem of when an oper was +xh and
	did -h, it gave the oper FEAT_HIDDEN_HOST and not
	FEAT_HIDDEN_OPERHOST.

	* ircd/s_auth.c: Modify AUTH_TIMEOUT from 60 to 30.

2003-07-04  Reed Loden  <reed@reedloden.com>

	* Happy Fourth of July!

	* Changed some of Math's REMOTEOPER code to use macros.

2003-07-01  Martijn Smit  <detsaw@users.sourceforge.net>

	* Added OPERHOST_HIDING and HIDDEN_OPERHOST.

2003-07-03  Reed Loden  <reed@reedloden.com>

	* Fix bugs in m_mkpasswd.c and m_ircops.c.

	* Revert parse.c to old version because db's new one is b0rked.

	* Removed login-on-connect.

	* Modified operhost patch to use "? :" construct rather than if
	and else.

	* Changed default server port and hidden host.

	* Backported some patches from u2.10.12.
	(FEAT_LOCAL_CHANNELS and brand new parse.c)

	* Added some fixes from asuka.

	* ircd/m_topic.c (do_settopic): If chan +m and -t don't let +b
	people set topic.
	(found by OUTsider but he had a broken patch)

	* Add a SSL fix from OUTsider.

	* Fix a typo in s_user.c made by Isomer.

	* Sync with u2.10.11.05...

2003-06-19  Reed Loden  <reed@reedloden.com>

	* Fixed the annoying assignment from incompatible pointer type 
	warning bug.
	(thanks IK)

2003-06-15  Reed Loden  <reed@reedloden.com>

	* Fix more bugs.

2003-06-13  Reed Loden  <reed@reedloden.com>

	* It's Friday the 13th! *BOO*	

	* Oops, forgot to commit makepem.

	* Synched Kev's fix of m_settime.c.

	* Fix bugs.

2003-06-12  Reed Loden  <reed@reedloden.com>

	* Added asuka's noquitparts.

	* Added OUTsider's botsupport.
	(no targetlimits/floodlimits/chanlimits)

	* Allow opers to see all channels in /whois.

	* Modified asuka's +c to reply with 480 on nocolour.

	* Added whoisservice (shows if client is +k).

	* Added OUTsider's whoisaccountonly (shows if client is +R).

	* Modified some FEAT_NEFARIOUS stuff.

	* Added asuka's opersendq patch (which was made by me).

	* Added several patches from SiRVulCaN.
	(/ircops, /mkpasswd, warn_change, chmodeslist)

2003-06-11  Reed Loden  <reed@reedloden.com>

	* Added SiRVulCaN's modified patch of Vampire-'s SSL patch.

2003-06-08  Reed Loden  <reed@reedloden.com>

	* Added two patches from ULtimaTe_.

	* Added some IRCu fixes from asuka.

	* Added asuka's topicburst (which in turn was made by Vampire-).

	* Added badnicks for X<numerics here> and then fixed it.
	(thanks IK and Rubin)

	* Added support for FEAT_HIS_STATS_u and FEAT_HIS_STATS_w.

	* Added several of my own patches that are still waiting to be
	committed to main IRCu CVS repository.

2003-05-10  Reed Loden  <reed@reedloden.com>

	* Synched to current u2_10_11_05.

	* Removed ASUKA's delayedjoin.

	* Removed S:lines to get ready for ASUKA's sethost.

	* Added ASUKA's sethost (not tested!!).

	* Fixed several bugs in sethost.
	NOTE: Need to tell QuakeNet Dev-Com about these bugs.

	* include/ircd_features.h, ircd/ircd_features.c: Added HIS_GLINE
	(default off).

	* ircd/gline.c: Fixed bugs in syncing.

	* ircd/s_user.c: Fixed gcc warning.

2003-01-21  Reed Loden  <reed@reedloden.com>

	* ircd/gline.c: Fixed nasty error due to missing ending bracket.

	* ircd/m_topic.c: member should have been sptr.

	* ircd/s_user.c: Forgot to change a FEAT_BOTSERVICE_CLASS to
	FEAT_BOT_CLASS.

	* Removed MODE_REGISTERED.

2003-01-15  Reed Loden  <reed@reedloden.com>

	* Added several ASUKA patches: delayedjoin, cC, accountonly,
	topicburst (needs to be fixed), and parts of badchan.

	* ircd/m_join.c: Added reason to BADCHAN kick message.

	* ircd/m_oper.c: Changed "No O: Lines" to "No O:line".

	* Added an edited version of OUTsider's botservice patch for
	use on Bots.*.

	* Renamed +r (REGONLY) to +R.

	* Added MODE_REGISTERED (+r) for when services are moved off
	of channels.

	* Removed SVSNICK since it's not what I have in mind. The
	new cloaking system will be started on soon.

2003-01-14  Mathieu Rene  <math@rootservices.net>

	* ircd/m_oper.c: Added remote OPER capability

	* ircd/m_join.c: Send reason instead of RPL_BANNEDFROMCHAN when
	attempting to join a BADCHAN'd channel + allow wildcards in badchans.

	* ircd/m_set.c: Added remote SET support

	* ircd/parse.c: Addes ms_set reference

	* ircd/table_gen.c: Forbid * in a channel name since this will break
	wildcards

	* ircd/client.c: Send privileges according to the defaults
	rather than using a hardcoded list.

	* ircd/ircd_features.c: Added a new feature: REMOTE_OPER, default
	to TRUE
	
	* include/client.h: Added FLAG_REMOTEOPER

	* include/ircd_features.h: Added a new feature: REMOTE_OPER,
	default to TRUE

	* include/msg.h: Added CMD_SET definition

	* include/handlers.h: Added ms_set prototype

2003-01-13  Mathieu Rene  <math@rootservices.net>

	* ircd/m_oper.c: Isolated OPER Authentication procedure
	
	* ircd/m_svsnick.c: Fixed stuff that didnt compile
	
	* ircd/s_conf.c: Fixed stuff that didnt compile

2003-01-11  Reed Loden  <reed@reedloden.com>

	* Add SVSNICK (several files modified).

	* ircd/s_conf.c: Make S:lines only work on users and not
	servers.

2003-01-10  Reed Loden  <reed@reedloden.com>

	* Add something from u2.10.12.

2003-01-09  Reed Loden  <reed@reedloden.com>

	* Sync to release version of u2.10.11.04.

	* include/patchlevel.h: Fix patchlevel so it fits. :P

	* ircd/ircd.c: Use FEAT_NEFARIOUS instead of another #define.

	* ircd/version.c.SH: Added nefarious to the list.

2003-01-06  Mathieu Rene  <math@rootservices.net>

	* ircd/m_privs.h (ms_privs): Added REMOTE privs support

	* include/handlers.h: Added ms_privs definition

	* include/msg.h: Added CMD_PRIVS

	* ircd/parse.c: Added ms_privs reference
	
	* ircd/ircd.c: Added #ifndef NOPIDFILE in the pidfile lock, for
	testnets

2003-01-01  Reed Loden  <reed@reedloden.com>

	* Sync of UnderNet IRCu.

	* ircd/ircd_features.c: Default CONFIG_OPERCMDS to TRUE.

	* ircd/m_links.c, ircd/m_map.c: Removed the part about CFV-165.

2002-12-30  Reed Loden  <reed@reedloden.com>

	* More work and syncing of UnderNet IRCu.

	* ircd/m_account.c: FLAGS to FLAG.

	* ircd/m_whois.c: Forgot an ending ')', again.

2002-11-23  Aaron Catella  <acatella@users.sourceforge.net>

	* ircd/channel.c: allow non-member channel services to PRIVMSG,
	NOTICE, WALLCHOPS, and WALLVOICE.

	* ircd/m_invite.c: allow non-member channel services to INVITE
	users.

	* ircd/m_kick.c: allow non-member channel services to KICK
	users.

	* ircd/m_topic.c: allow non-member channel services to change
	TOPICs.

2002-12-29  Reed Loden  <reed@reedloden.com>

	* Added main AfterNET defaults. Full ChangeLog coming soon.

2002-12-28  Mathieu Rene  <math@rootservices.net>

	* ircd/s_user.c (set_user_mode): Allow remote mode for a user by
	a server.

	* ircd/m_opmode.c (m_opmode): Blocked opmode for registered
	channels.

	* ircd/m_clearmode.c (m_clearmode): Blocked clearmode for
	registered channels.

2002-12-28  Reed Loden  <reed@reedloden.com>

	* Imported u2_10_11_04 into CVS.

***********************************************************************/

#define CVS_VERSION "$Id: ChangeLog.nefarious 2212 2008-08-03 08:18:56Z jobe1986 $"
